/***************************************************************************
                          ancestorstream.cpp  -  description
                             -------------------
    begin                : Fri Dec 19 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ancestorstream.h"
#include "writer.h"

namespace limpid {

AncestorStream::AncestorStream(bool includeSelf): includeSelf_(includeSelf) {
  reset();
}

AncestorStream::AncestorStream(Node& rt, bool includeSelf): includeSelf_(includeSelf) {
  setRoot(rt);
}

Node& AncestorStream::nextNode() {
  if (!root_) return Node::failNode;

  if (!lastNode_) {
    if (includeSelf_) lastNode_ = root_;
    else lastNode_ = &root_->getParentNode();
  }
  else
    lastNode_ = &lastNode_->getParentNode();

  if (lastNode_->getNodeType() == Node::DOCUMENT_NODE)
    lastNode_ = &Node::failNode;

  return *lastNode_;
}

void AncestorStream::setRoot(const Node& rt) {
  reset();
  root_ = &const_cast<Node &>(rt);
}

void AncestorStream::reset() {
  root_ = 0;
  lastNode_ = 0;
}

}
