/***************************************************************************
                          ancestorstream.h  -  description
                             -------------------
    begin                : Fri Dec 19 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ANCESTORSTREAM_H
#define ANCESTORSTREAM_H

#include "nodesource.h"

/**
This NodeSource provides a stream of all the ancestors of the root node. The inclSlf flag (to include the root node itself) defaults to false.

  @author root <john_redmond@optusnet.com.au>
*/
namespace limpid {
  class AncestorStream : public NodeSource  {
  public:
    AncestorStream(bool includeSelf = false);
    AncestorStream(Node& root, bool includeSelf = false);

    Node& nextNode();
    AncestorStream& copy() { return *(new AncestorStream(*this)); }
    void setRoot(const Node& rt);

  private:
    Node *root_, *lastNode_;
    bool includeSelf_;

    void reset();
  };
}
#endif
