/***************************************************************************
                          applytemplate.h  -  description
                             -------------------
    begin                : Sat Oct 2 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef APPLYTEMPLATE_H
#define APPLYTEMPLATE_H

#include "template.h"
#include "selectionmanager.h"
#include "matchedtemplate.h"
#include "defaulttemplate.h"
#include "templatelauncher.h"
#include "compoundtemplate.h"
#include "xslcontext.h"
#include "expressionmap.h"

/**
This Template processes a Context with a group of child Templates.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class Node;
  class NodeSet;

  class ApplyTemplate : public Template  {
  public:
    ApplyTemplate(const DOMString& selectString, const DOMString& modeString,
    bool useImports = false);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }
    void addSortTemplate(Template& childTemplate) { wrt::Errors << "ADD SORT\n"; sortTemplates_.addTemplate(childTemplate); }
    void setParameter(const DOMString& key, const Expr& expr) {
      parameters_.setExpr(key, expr); }
    void setResources(XSLResources& resources);
    ApplyTemplate& copy() { return *(new ApplyTemplate(*this)); }

  private:
    Expr expr_;
    DOMString modeString_;
    ExpressionMap parameters_;
    CompoundTemplate templates_, sortTemplates_;
    SelectionManager selectionManager_;
    DefaultTemplate defaultTemplate_;
  };
}


#endif
