/***************************************************************************
                          argparser.cpp  -  description
                             -------------------
    begin                : Mon May 8 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "argparser.h"
#include "stringreader.h"
#include "tokenstream.h"

namespace limpid {

ArgParser::ArgParser(const DOMString& argString, Char separatorChar):
    argList_(new ArgList), separatorChar_(separatorChar) {
  parse(argString);
}

DOMString ArgParser::getArg(size_t index) {
  if (index >= argList_->size()) return "";
  return (*argList_)[index];
}

void ArgParser::parse(const DOMString& argString) {
  StringReader stream(argString);
  TokenStream tis(stream);
  tis.setWhitespaceChars(separatorChar_);

  // dissect the parameter string at the separator chars (if any)
  while (tis.isValid()) {
    argList_->push_back(tis.nextToken());
  }
}

}

