/***************************************************************************
                          argparser.h  -  description
                             -------------------
    begin                : Mon May 8 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ARGPARSER_H
#define ARGPARSER_H

#include <vector>
#include "pointer.h"
#include "domstring.h"

/**
ArgParser parses a string with embedded separator chars (the default is '+') and
provides easy access to the resultant substrings.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class ArgParser {
  public:
    ArgParser(const DOMString& argString, Char separatorChar = '+');
    DOMString getArg(size_t index);
    size_t getArgCount() { return argList_->size(); }

  private:
    typedef std::vector<DOMString> ArgList;
    Pointer<ArgList> argList_;
    Char separatorChar_;
    
    void parse(const DOMString& argString);
  };
}

#endif
