/***************************************************************************
                          arithmeticcomponent.h  -  description
                             -------------------
    begin                : Thu May 27 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ARITHMETICCOMPONENT_H
#define ARITHMETICCOMPONENT_H

#include "parentcomponent.h"
#include "domstring.h"

/**
This DocumentProcessor removes all attributes from a document.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class ArithmeticComponent : public ParentComponent  {
  public:
    enum ArithmeticType { ADD, SUBTRACT, MULTIPLY, DIVIDE, MOD };
  	ArithmeticComponent(const DOMString& type);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context);
    Number getNumber(Context& context);
    Expr eval(Context& context) { return getNumber(context); }

    ArithmeticComponent& copy() { return *(new ArithmeticComponent(*this)); }

  protected:
    ArithmeticType type_;

    void setType(const DOMString& type);
  };
}

#endif
