/***************************************************************************
                          attributecontent.cpp  -  description
                             -------------------
    begin                : Wed Sep 10 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attributecontent.h"
#include "nodelist.h"

namespace limpid {

AttributeContent::AttributeContent(const DOMString& name, ParentNode& parent):
  ParentContent(Node::ATTRIBUTE_NODE, name, parent),
  namespaceURI_(0) {
}

AttributeContent::~AttributeContent() {
  delete [] namespaceURI_;
}

size_t AttributeContent::getSize() {
  size_t size = sizeof(*this);

  if (prefix_) size += (DOMString::strLength(prefix_) + 1) * sizeof(Char);
  size += (DOMString::strLength(nodeName_) + 1) * sizeof(Char);
  if (namespaceURI_) size += (DOMString::strLength(namespaceURI_) + 1) * sizeof(Char);
  if (childNodes_) {
    size += childNodes_->getSize();
    size_t length = childNodes_->getLength();
    for (size_t i = 0; i < length; i++)
      size += childNodes_->item(i).getSize();
  }
  return size;
}

}
