/***************************************************************************
 *   Copyright (C) 2007 by John Redmond   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDATTRIBUTECONVERTER_H
#define LIMPIDATTRIBUTECONVERTER_H

#include "documentprocessor.h"
#include "domutils.h"

/**
This is a DocumentProcessor that converts all specified attributes to elements.

  @author root <root@john_redmond@optusnet.com.au>
*/

namespace limpid {

class AttributeConverter: public DocumentProcessor, public DOMUtils {

  public:
    AttributeConverter(const DOMString& attributeName);

    Document& processDocument(Document& inputDocument);
    AttributeConverter& copy() { return *(new AttributeConverter(*this)); }

  private:
    DOMString attributeName_;

    void copyChildren(Node& sourceNode, Node& destNode);
};

}

#endif
