  /***************************************************************************
                          attributesettemplate.cpp  -  description
                             -------------------
    begin                : Mon Jul 18 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attributesettemplate.h"
#include "domstring.h"
#include "element.h"
#include "stringreader.h"
#include "tokenstream.h"

namespace limpid {

AttributeSetTemplate::AttributeSetTemplate(const DOMString& attributeNames):
      Template(attributeNames), attributeSetNames_(new StringList) {
  configure(attributeNames);
}

bool AttributeSetTemplate::process(XSLContext& parentContext) {
  if (attributeSetNames_->empty())  return true;
  if (parentContext.getNode().getNodeType() != Node::ELEMENT_NODE) return true;

  StringList::iterator p = attributeSetNames_->begin();
  StringList::iterator end = attributeSetNames_->end();
  while (p != end) {
///    resources_.getAttributeSetTemplate(*p).process(parentContext);
    ++p;
  }

  return true;
}

bool AttributeSetTemplate::processNode(XSLContext& parentContext, Node& node) {
  if (attributeSetNames_->empty())  return true;

  if (parentContext.getNode().getNodeType() != Node::ELEMENT_NODE) return true;

  StringList::iterator p = attributeSetNames_->begin();
  StringList::iterator end = attributeSetNames_->end();
  while (p != end) {
///    resources_.getAttributeSetTemplate(*p).processNode(parentContext, node);
    ++p;
  }

  return true;
}

void AttributeSetTemplate::configure(const DOMString& attributeSetNames) {
  StringReader reader(attributeSetNames);
  TokenStream tis(reader);

  while (true) {
    DOMString token = tis.nextToken();
    if (token.empty()) break;

    attributeSetNames_->push_back(token);
  }
}

}

