/***************************************************************************
                          attributesettemplate.h  -  description
                             -------------------
    begin                : Mon Jul 18 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTESETTEMPLATE_H
#define ATTRIBUTESETTEMPLATE_H

#include "template.h"
#include "xslresources.h"
#include <vector>
#include "pointer.h"
#include "domstring.h"

/**
AttributeSetTemplate is a Template to specify an Attribute to be set on a
result Element in and XSLT tranformation.

  @author root <john_redmond@optusnet.com.au>
*/


namespace limpid {
  class DOMString;

  class AttributeSetTemplate : public Template  {
  public:
    AttributeSetTemplate(const DOMString& attributeName);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    void setResources(XSLResources& resources) { resources_ = resources; }
    bool isAttribute() { return true; }
    AttributeSetTemplate& copy() { return *(new AttributeSetTemplate(*this)); }

  private:
    typedef std::vector<DOMString> StringList;
    Pointer<StringList> attributeSetNames_;
    XSLResources resources_;

    void configure(const DOMString& attributeSetNames);
  };
}

#endif
