/***************************************************************************
                          attributespec.h  -  description
                             -------------------
    begin                : Thu Jan 8 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTESPEC_H
#define ATTRIBUTESPEC_H

#include <set>
#include "domstring.h"
/**
AttributeSpec is an internal class to support document validation.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  typedef std::set<DOMString> Enumeration;
  class AttributeSpec {
    public:
      enum Type {STRING, ENTITY, ENTITIES, NOTATION, NMTOKEN, ID, IDREF, IDREFS};
      AttributeSpec(DOMString& defVal);
      ~AttributeSpec();

      void addEnumeration(DOMString& s) { enumeration.insert(s); }
      bool hasEnumeration() { return !enumeration.empty(); }
      size_t getSize() const;

      Type type;
      bool required, fixed;
      DOMString defaultValue;
      Enumeration enumeration;
  };
}
#endif
