/***************************************************************************
                          attributestream.cpp  -  description
                             -------------------
    begin                : Mon Dec 15 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attr.h"
#include "attributestream.h"

namespace limpid {

AttributeStream::AttributeStream(): attributeMap(0), index(0) {
}

AttributeStream::AttributeStream(NamedNodeMap& map):
      attributeMap(&map), index(0) {
}

AttributeStream::AttributeStream(Node& parent):
      attributeMap(&parent.getAttributes()), index(0) {
}

Node& AttributeStream::nextNode() {
  if (attributeMap && index < attributeMap->getLength())
    return attributeMap->item(index++);
  else return Attr::failAttr;
}

void AttributeStream::setRoot(const Node& root) {
  attributeMap = &root.getAttributes();
  index = 0;
}

}
