/***************************************************************************
                          attributestream.h  -  description
                             -------------------
    begin                : Mon Dec 15 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTESTREAM_H
#define ATTRIBUTESTREAM_H

#include "nodesource.h"
#include "namednodemap.h"

/**
AttributeStream provides a NodeSource for the attributes of an Element or
NamedNodeMap.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class AttributeStream : public NodeSource  {
  public:
    AttributeStream();
    AttributeStream(NamedNodeMap& map);
    AttributeStream(Node& parent);

    Node& nextNode();
    void setRoot(const Node& root);
    AttributeStream& copy() { return *(new AttributeStream(*this)); }

  private:
    NamedNodeMap *attributeMap;
    size_t index;

    void copyContent(const AttributeStream& refStream);
  };
}
#endif
