/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDATTRIBUTESTRIPPER_H
#define LIMPIDATTRIBUTESTRIPPER_H

#include "documentprocessor.h"
#include "domstring.h"

/**
This DocumentProcessor is a DocumentProcessor that removes all attributes from a document.

  @author root <root@john_redmond@optusnet.com.au>
*/

namespace limpid {

class AttributeStripper: public DocumentProcessor {

  public:
    AttributeStripper(const DOMString& attrName): attrName_(attrName) {}

    Document& processDocument(Document& inputDocument);
    AttributeStripper& copy() { return *(new AttributeStripper(*this)); }

  private:

    DOMString attrName_;
};

}

#endif
