/***************************************************************************
                          attributetemplate.h  -  description
                             -------------------
    begin                : Fri Jul 1 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ATTRIBUTETEMPLATE_H
#define ATTRIBUTETEMPLATE_H

#include "compoundtemplate.h"
#include "domstring.h"
#include "expr.h"

/**
AttributeTemplate sets an Attr on an Element being generated by XSLT, or outputs
equivalent text if the transformation is in streaming mode.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class XSLContext;

  class AttributeTemplate : public Template  {
  public:
  	AttributeTemplate(const DOMString& name, Expr& nameExpr, Expr& valueExpr);
  	AttributeTemplate(const DOMString& name, Expr& nameExpr,
        Expr& uriExpr, Expr& valueExpr);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    bool isAttribute() { return true; }
    AttributeTemplate& copy() { return *(new AttributeTemplate(*this)); }

  private:
    Expr nameExpr_, uriExpr_, valueExpr_;
  };
}

#endif
