/***************************************************************************
                          attributetest.cpp  -  description
                             -------------------
    begin                : Sat Aug 16 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attributetest.h"
#include "writer.h"

namespace limpid {

AttributeTest::AttributeTest(const DOMString& name, const DOMString& value):
    refName(name), refValue(value) {
  matchValue = refValue.size();
}

bool AttributeTest::test(Node& node) {
  if (node.getNodeType() != Node::ELEMENT_NODE) return false;

  DOMString value = ((Element &)node).getAttribute(refName);
  if (!value.size()) return false;
  if (!matchValue) return true;
  return (value == refValue);
}

}
