/***************************************************************************
                          availableexpression.cpp  -  description
                             -------------------
    begin                : Thu May 12 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "availableexpression.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "nodeset.h"

namespace limpid {

AvailableExpression::AvailableExpression(const DOMString& availableName) {
  if (availableName == "element-available")
    reportType_ = ELEMENT;
  else
    reportType_ = FUNCTION;
}

Boolean AvailableExpression::getBoolean(Context& context) {
  if (!getLength()) return false; // should never happen: == no parameter
  DOMString queryName = getItem(0).getString(context);
  return doMatch(queryName);
}

// This function will need to be updated when elements and functions are added
bool AvailableExpression::doMatch(const DOMString&) {
  if (reportType_ == ELEMENT)
    return false;
  else
    return false;
}

}
