/***************************************************************************
                          availableexpression.h  -  description
                             -------------------
    begin                : Thu May 12 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef AVAILABLEEXPRESSION_H
#define AVAILABLEEXPRESSION_H

#include "parentcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "nodeset.h"

/**
AvailableExpression is an internal class to support XPath.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class Boolean;
  class DOMString;
  class Context;

  class AvailableExpression: public ParentComponent {
    public:
    	AvailableExpression(const DOMString& availableName);

      Boolean getBoolean(Context& context);
      XPathString getString(Context& context) {
        return getBoolean(context).getString(context); }
      Number getNumber(Context& context) {
        return getBoolean(context).getNumber(context); }
      NodeSet getNodeSet(Context&, bool) {
        NodeSet nodeSet; return nodeSet; }
      Expr eval(Context& context) { return getBoolean(context); }

      virtual double getPriority() { return -1000; }
      virtual bool isNodeSet() { return false; }
      virtual bool isBoolean() { return false; }
      AvailableExpression& copy() { return *(new AvailableExpression(*this)); }

    private:
      enum Type { ELEMENT, FUNCTION };

      Type reportType_;

      bool doMatch(const DOMString& queryString);
  };

}
#endif
