/***************************************************************************
                          boolean.cpp  -  description
                             -------------------
    begin                : Mon Feb 16 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "expr.h"

namespace limpid {

Boolean::Boolean(bool value): XPathExpression(), value_(value) {
}

Boolean::Boolean(int value): XPathExpression(), value_(value) {
}

Boolean::Boolean(double value): XPathExpression(), value_(value != 0) {
}

XPathString Boolean::getString(Context&) {
  if (value_) return "true";
  else return "false";
}

Number Boolean::getNumber(Context&) {
  if (value_) return 1;
  else return 0;
}

Expr Boolean::eval(Context& context) {
  return getNumber(context);
}


}

