/***************************************************************************
                          boolean.h  -  description
                             -------------------
    begin                : Mon Feb 16 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BOOLEAN_H
#define BOOLEAN_H

#include "xpathexpression.h"

/**
Boolean models a boolean comparison in an XPath expression.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class XPathString;
  class Number;
  class Expr;

  class Boolean : public XPathExpression {
  public:
  	Boolean(bool value);
    Boolean(int value);
    Boolean(double value);

    Boolean getBoolean(Context&) { return *this; }
    XPathString getString(Context& context);
    Number getNumber(Context& context);
    Expr eval(Context& context);

    bool isTrue() { return value_; }
    bool isBoolean() { return true; }
    bool isValid() { return true; }

    Boolean& copy() { return *(new Boolean(*this)); }

  private:
    bool value_;
  };
}

#endif
