/***************************************************************************
                          booleancomparison.cpp  -  description
                             -------------------
    begin                : Wed Jun 2 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "booleancomparison.h"
#include "writer.h"

namespace limpid {

BooleanComparison::BooleanComparison(Type t, bool logic): NumberComparison(t,logic) {
}

BooleanComparison::BooleanComparison(const DOMString& modeString):
      NumberComparison(modeString) {
}

Boolean BooleanComparison::getBoolean(Context& context) {
  if (getLength() != 2) return false;
    bool firstBool = components->at(0)->getBoolean(context).isTrue();
    bool secondBool = components->at(1)->getBoolean(context).isTrue();

    bool result;
    if (type_ == EQ) result = firstBool == secondBool;
    else if (type_ == LT) result = !firstBool && secondBool;
    else result = firstBool && !secondBool;

    return result == logic_;
}

}
