/***************************************************************************
                          booleancomparison.h  -  description
                             -------------------
    begin                : Wed Jun 2 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BOOLEANCOMPARISON_H
#define BOOLEANCOMPARISON_H

#include "numbercomparison.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

/**
BooleanComparison is an internal class to support a boolean subexpression in XPath.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class BooleanComparison : public NumberComparison  {
  public:
  	BooleanComparison(Type t = EQ, bool log = true);
    BooleanComparison(const DOMString& modeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    BooleanComparison& copy() { return *(new BooleanComparison(*this)); }
  };
}

#endif
