/***************************************************************************
                          booleangenerator.cpp  -  description
                             -------------------
    begin                : Tue Jun 15 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "booleangenerator.h"
#include "writer.h"

namespace limpid {

BooleanGenerator::BooleanGenerator(ContextType type):
  ParentComponent(), type_(type), logic_(true) {
}

BooleanGenerator::BooleanGenerator(const DOMString& typeString):
      ParentComponent() {
  setType(typeString);
}

Boolean BooleanGenerator::getBoolean(Context& context) {
  if (!getLength()) return false;
  if (type_ == LANG) return true;

  Boolean result = getItem(0).getBoolean(context);

  if (logic_) return result.isTrue();
  else return !result.isTrue();
}

void BooleanGenerator::setType(const DOMString& typeString) {
  type_ = TRUTH;
  logic_ = true;

  if (typeString == "boolean")
    logic_ = true;
  else if (typeString == "not")
    logic_ = false;
  else if (typeString == "lang")
    type_ = LANG;
}

}
