/***************************************************************************
                          booleangenerator.h  -  description
                             -------------------
    begin                : Tue Jun 15 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BOOLEANGENERATOR_H
#define BOOLEANGENERATOR_H

#include "parentcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

/**
BooleanGenerator models a boolean subexpression in XPath and returns appropriate
XPath expressions.

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class BooleanGenerator : public ParentComponent  {
  public:
    enum ContextType { TRUTH, LANG };
    BooleanGenerator(ContextType);
    BooleanGenerator(const DOMString& typeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    BooleanGenerator& copy() { return *(new BooleanGenerator(*this)); }

  private:
    ContextType type_;
    bool logic_;

    void setType(const DOMString& typeString);
  };
}

#endif
