/***************************************************************************
                          builder.h  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BUILDER_H
#define BUILDER_H


/**
  *@author John Redmond
  */

#include <deque>
//#include "nodestack.h"
#include "processor.h"
#include "node.h"
#include "document.h"
#include "parentnode.h"
#include "nodelist.h"
#include "domwriter.h"

namespace limpid {
  class Builder: public Processor {
  public:
    Builder(bool checkBalance = false);
    Builder(Node& rootNode, bool checkBalance = false);

    Node& process(Node& node);
    Document& getDocument();
    Node& getCurrentNode() { if (currentNode_) return *currentNode_; return Node::failNode; }
    void setCheckBalance(bool checkBalance) { checkBalance_ = checkBalance; }
    Builder& copy() { return *(new Builder(*this)); }

  private:
//    typedef std::deque<Pointer<Node> > NodeStack;
    typedef std::deque<Node *> NodeStack;

    Document document_;
    Node *currentNode_;  // not managed
    NodeStack nodeStack_;
    bool checkBalance_;

    void push(Node& node);
    void pop();
    void emptyStack();
    void reportStackErrors();
  };
}
#endif
