/***************************************************************************
                          calltemplate.cpp  -  description
                             -------------------
    begin                : Fri Nov 5 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "calltemplate.h"
#include "contexthandler.h"
#include "writer.h"

namespace limpid {

CallTemplate::CallTemplate(DOMString& called, bool isImported): Template(called),
  calledName_(called), selectionManager_(isImported) {}

bool CallTemplate::process(XSLContext& parentContext) {
  XSLContext context;
  context.setParent(parentContext);

  Template& calledTemplate = selectionManager_.getCalledTemplate(calledName_);
  if (calledTemplate.isValid()) {
    calledTemplate.passParameters(parameters_, context);
    calledTemplate.process(context);
  }

  return true;
}

bool CallTemplate::processNode(XSLContext& parentContext, Node& node) {
  XSLContext context;
  context.setParent(parentContext);

  Template& calledTemplate = selectionManager_.getCalledTemplate(calledName_);
  if (calledTemplate.isValid()) {
    calledTemplate.passParameters(parameters_, context);
    calledTemplate.processNode(context, node);
  }

  return true;
}

void CallTemplate::setParameter(const DOMString& key, const Expr& expr) {
  parameters_.setExpr(key, expr);
}

}

