/***************************************************************************
                          calltemplate.h  -  description
                             -------------------
    begin                : Fri Nov 5 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CALLTEMPLATE_H
#define CALLTEMPLATE_H

#include "domstring.h"
#include "compoundtemplate.h"
#include "expressionmap.h"
#include "selectionmanager.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;
  class XSLContext;

  class CallTemplate : public Template  {
  public:
  	CallTemplate(DOMString& calledName, bool isImported);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);

    void setResources(XSLResources& resources) { selectionManager_.setResources(resources); }
    void setParameter(const DOMString& key, const Expr& expr);

    CallTemplate& copy() { return *(new CallTemplate(*this)); }

  private:
    DOMString calledName_;
    ExpressionMap parameters_;
    SelectionManager selectionManager_;
  };
}

#endif
