/***************************************************************************
 *   Copyright (C) 2006 by John Redmond   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CCPARSER_H
#define CCPARSER_H

#include <vector>
#include "endnode.h"
#include "parser.h"
#include "pointer.h"
#include "reader.h"
#include "tokenstream.h"
#include "node.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;

  class CCParser : public Parser  {
  public:
    CCParser(const DOMString& fileName);
//    CCParser(const Reader& characterStream);

    Node& nextNode();
    CCParser& copy() { return *(new CCParser(*this)); }

  private:
    typedef std::vector<DOMString> StringVector;
    Pointer<Node> node_;
    Pointer<Reader> reader_;
    Pointer<TokenStream> tis_;
    DOMString line_;
    EndNode endNode_;
    int delimiterChar_, lineNo_;
    bool isStarted_, useLabels_, hasLabels_, nodeSent_;
    DOMString delimiterString_;

    void parseLine(DOMString& rowName);
    bool setLine();
    void setColumn(Node& entryElement, DOMString& value, size_t index);
    void configure();
  };
}

#endif
