/***************************************************************************
                          cdatasection.cpp  -  description
                             -------------------
    begin                : Sat May 3 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cdatasection.h"
#include "document.h"

using std::string;

namespace limpid {

CDATASection::CDATASection(const DOMString& s): Text(CDATA_SECTION_NODE, s) {
  CharacterContent *contentPtr = static_cast<CharacterContent *>(nodeContent_);
  contentPtr->nodeType_ = CDATA_SECTION_NODE;
}

CDATASection::CDATASection(const CDATASection& refNode): Text(refNode) {
}

Node& CDATASection::operator=(const CDATASection& refNode) {
  replaceContent(refNode);
  return *this;
}

DOMString CDATASection::getDisplayString() const {
  DOMString returnString("<[CDATA[");
  returnString += getData();
  returnString.change("]]>", "&#x5B}>");
  returnString += "]]>";

  return returnString;
}

Node& CDATASection::cloneNode(bool) const {
  CharacterContent *contentPtr = static_cast<CharacterContent *>(nodeContent_);
  DOMString data = contentPtr->data_;

  CDATASection *clone = new CDATASection(data);
  clone->nodeContent_->documentContent_ = nodeContent_->documentContent_;
  getOwnerDocument().cacheNode(*clone);

  return *clone;
}

}
