/***************************************************************************
                          characterdata.h  -  description
                             -------------------
    begin                : Wed Sep 10 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHARACTERDATA_H
#define CHARACTERDATA_H

#include "node.h"
#include "charactercontent.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class CharacterData : public Node  {
  public:

  //DOM:
    DOMString getData() const;
    void setData(const DOMString& newData);
    size_t getLength() const;
    DOMString substringData(size_t offset, size_t count) const;
    void appendData(const DOMString& extra);
    void insertData(size_t offset, const DOMString& extra);
    void deleteData(size_t offset, size_t count);
    void replaceData(size_t offset, size_t count, const DOMString& extra);
    void setNodeValue(const DOMString& val) { setData(val); }

  //non-DOM:
    DOMString getRawValue() const { return getData(); }
    DOMString getNodeValue() const { return getData(); }
    DOMString getValue() const { return getData(); }
    size_t getSize();

  protected:
    CharacterData(NodeType nodeType);
  	CharacterData(NodeType nodeType, const DOMString& data);
    CharacterData(const CharacterData&);
    CharacterData& operator=(const CharacterData&);
  };
}
#endif
