/***************************************************************************
                          charactervalidator.h  -  description
                             -------------------
    begin                : Tue Oct 21 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHARACTERVALIDATOR_H
#define CHARACTERVALIDATOR_H

#include "writer.h"
#include "domstring.h"
#include "converter.h"
/**
  *@author John Redmond
*/

namespace limpid {
  class CharacterValidator: protected Converter {
    public:
      CharacterValidator();
      ~CharacterValidator();
      // default copy ctor and assignment are OK

      bool isXMLChar(int c);
      bool getMatch(int testChar, int options[]);
      bool isWhitespaceChar(int c);
      bool isLetterChar(int c);
      bool isFirstChar(int c);
      bool isXMLNameChar(int c);
      bool isXMLNameStartChar(int c);
      int checkValidName(DOMString& name, int lineNo);
      int checkValidElementName(DOMString& name, int lineNo);
      bool checkValidAttributeName(DOMString& elementName, DOMString& name, int lineNo);
      bool checkValidNameToken(DOMString& elementName, DOMString& name, int lineNo);
      bool checkValidAttributeValue(DOMString& elementName, DOMString& value, int lineNo);
      bool checkValidText(DOMString& value, int lineNo);

      void setWriter(Writer& wr) { writer = wr; }
      size_t getSize();

    protected:
      Writer writer;
      static int baseChars[];
      static int ideographicChars[];
      static int combiningChars[];
      static int digitChars[];
      static int extenderChars[];
      static int whitespaceChars[];
  };
}
#endif
