/***************************************************************************
                          characterwriter.h  -  description
                             -------------------
    begin                : Thu Jun 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHARACTERWRITER_H
#define CHARACTERWRITER_H

#include "copied.h"
#include "iobase.h"
#include "url.h"
#include "converter.h"
#include "node.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class CharacterWriter : public Copied, public IOBase  {
  public:
  	CharacterWriter();

    virtual void setEncoding(Encoding) {}
    virtual void setEncoding(const DOMString&) {}
    virtual int putChar(int c) { return c; }
    virtual bool isValid() { return false; }
    virtual URL getURL() { return URL(); }
    virtual void flush() {}
    virtual void close() {}
    virtual DOMString getPath() { return "CharacterWritre"; }

    CharacterWriter& putString(const DOMString& s) { size_t size = s.size(), index = 0;
      while (index < size) putChar(int(s[index++])); return *this; }
    CharacterWriter& copy() { return *(new CharacterWriter(*this)); }
};

  // non-member functions:

  CharacterWriter& operator<<(CharacterWriter& w, const char c);
  CharacterWriter& operator<<(CharacterWriter& w, const Char c);
  CharacterWriter& operator<<(CharacterWriter& w, const DOMString& s);
  CharacterWriter& operator<<(CharacterWriter& w, const char* s);
  CharacterWriter& operator<<(CharacterWriter& w, const Char* s);
  CharacterWriter& operator<<(CharacterWriter& w, int i);
  CharacterWriter& operator<<(CharacterWriter& w, size_t i);
  CharacterWriter& operator<<(CharacterWriter& w, long int i);
  CharacterWriter& operator<<(CharacterWriter& w, unsigned long int i);
  CharacterWriter& operator<<(CharacterWriter& w, double d);
  CharacterWriter& operator<<(CharacterWriter& w, void* p);
  CharacterWriter& operator<<(CharacterWriter& w, const void* p);
  CharacterWriter& operator<<(CharacterWriter& w, bool flag);
  CharacterWriter& operator<<(CharacterWriter& w, const Node& node);
}

#endif
