/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "choicepoint.h"

namespace limpid {

ChoicePoint::ChoicePoint() { type_ = CHOICE; }

ChoicePoint::ChoicePoint(const Element& element, const DOMString& name): SequencePoint(element, name) {
  setFrequency(element);
  addContent(element);
  type_ = CHOICE;
}

bool ChoicePoint::test(Node& node) {
  for (int index = 0; index < childPointers_->size(); ++index) {
    MatchPoint& indexPoint = *childPointers_->at(index);
    if (indexPoint.isAvailable() && indexPoint.test(node)) {
      return true;
    }
  }

  return false;
}

void ChoicePoint::traverse(const DOMString& indent) {
  DOMString newIndent = indent;
  newIndent += "  ";

  doTraversal(newIndent);
}

}
