/***************************************************************************
                          cloneparser.cpp  -  description
                             -------------------
    begin                : Thu Jun 8 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cloneparser.h"

namespace limpid {

CloneParser::CloneParser(NodeSource& nodeSource, bool deep):
  nodeSource_(&nodeSource.copy()), deep_(deep) {}

Node& CloneParser::nextNode() {
  Node& node = nodeSource_->nextNode();
  if (!node.isValid()) return node;

  node_ = &node.cloneNode(deep_);
  return *node_;
}

}
