/***************************************************************************
                          collectionprocessor.cpp  -  description
                             -------------------
    begin                : Thu Aug 14 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "collectionprocessor.h"

namespace limpid {

CollectionProcessor::CollectionProcessor(Test& test):
  theTest(&test.copy()), nodes(new NodeList) {
}

Node& CollectionProcessor::start( Node& node) {
  return theTest->start(node);
}

Node& CollectionProcessor::process(Node& node) {
  if (theTest->test(node))
    nodes->addNode(node);
  return node;
}

NodeList CollectionProcessor::getNodes() {
  return *nodes;
}

}
