/***************************************************************************
                          collectionprocessor.h  -  description
                             -------------------
    begin                : Thu Aug 14 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COLLECTIONPROCESSOR_H
#define COLLECTIONPROCESSOR_H

#include "processor.h"
#include "nodelist.h"
#include "test.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class CollectionProcessor : public Processor  {
  public:
  	CollectionProcessor(Test& test);

    void clearNodes() { nodes->clear(); }
    Node& start(Node& node);
    Node& process(Node& node);
    NodeList getNodes();
    CollectionProcessor& copy() { return *(new CollectionProcessor(*this)); }

  private:
    Pointer<Test> theTest;
    Pointer<NodeList> nodes;

    void copyContent(const CollectionProcessor& refProcessor);
    void deleteContent();

  };
}
#endif
