/***************************************************************************
                          collectorcomponent.cpp  -  description
                             -------------------
    begin                : Mon May 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "collectorcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "writer.h"

namespace limpid {

CollectorComponent::CollectorComponent(NodeSetProcessor& coll): collector(&coll.copy()) {
}

Boolean CollectorComponent::getBoolean(Context& context) {
  getNodeSet(context);
  return static_cast<int>(nodeSet.getLength());
}

XPathString CollectorComponent::getString(Context& context) {
  getNodeSet(context);
  if (nodeSet.getLength())
    return nodeSet.getItem(0).getValue();
  else return "";
}

Number CollectorComponent::getNumber(Context& context) {
  return getNodeSet(context).getString(context).getNumber(context);
}

NodeSet CollectorComponent::getNodeSet(Context& context, bool exact) {
  nodeSet = collector->process(context.getNode(), context, exact);
  return nodeSet;
}

}
