/***************************************************************************
                          collectorcomponent.h  -  description
                             -------------------
    begin                : Mon May 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COLLECTORCOMPONENT_H
#define COLLECTORCOMPONENT_H

#include "xpathexpression.h"
#include "nodesetprocessor.h"
#include "nodelist.h"
#include "context.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class CollectorComponent : public XPathExpression {
  public:
  	CollectorComponent(NodeSetProcessor& collector);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context);
    Number getNumber(Context& context);

    bool isValid() { return true; }
    Expr eval(Context& context) { return getNodeSet(context); }

    NodeSet getNodeSet(Context& context, bool exact = true);
    CollectorComponent& copy() { return *(new CollectorComponent(*this)); }

    bool isNodeSet() { return true; }
    size_t getLength(Context& context) { return getNodeSet(context, true).getLength(); }
    Node& getItem(size_t index) { return nodeSet.item(index); }

  protected:
    Pointer<NodeSetProcessor> collector;
    NodeSet nodeSet; // volatile value
  };
}

#endif
