/***************************************************************************
                          comment.cpp  -  description
                             -------------------
    begin                : Fri Sep 12 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "comment.h"
#include "document.h"

namespace limpid {

Comment::Comment(const DOMString& data):
      CharacterData(Node::COMMENT_NODE, data) {
}

Comment::Comment(const Comment& refNode): CharacterData(refNode) {
}

Comment& Comment::operator=(const Comment& refNode) {
  replaceContent(refNode);
  return *this;
}

Node& Comment::cloneNode(bool) const{
  CharacterContent *contentPtr = static_cast<CharacterContent *>(nodeContent_);
  DOMString data = contentPtr->data_;

  Comment *clone = new Comment(data);
  clone->nodeContent_->documentContent_ = nodeContent_->documentContent_;
  getOwnerDocument().cacheNode(*clone);

  return *clone;
}

DOMString Comment::getDisplayString() const {
  CharacterContent *contentPtr = static_cast<CharacterContent *>(nodeContent_);
  DOMString s = "<!--";
  s += contentPtr->data_;
  s += "-->";

  return s;
}

}
