/***************************************************************************
                          commenttemplate.cpp  -  description
                             -------------------
    begin                : Mon Oct 10 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "commenttemplate.h"
#include "comment.h"
#include "stringwriter.h"

namespace limpid {

CommentTemplate::CommentTemplate() {}

bool CommentTemplate::process(XSLContext& parentContext) {
  writeFormat(parentContext);

  CharacterWriter& writer = parentContext.getWriter();

  writer << "<!--";
  templates_.process(parentContext);
  writer << "-->";// << wrt::endl;

  return true;
}

bool CommentTemplate::processNode(XSLContext& parentContext, Node& node) {
  if (node.getNodeType() != Node::ELEMENT_NODE) return true;  // cannot add comment

  XSLContext context;
  context.setParent(parentContext); 

  StringWriter stringWriter;
  context.setWriter(stringWriter);

  templates_.process(context);

  Comment comment(stringWriter.getString());
  node.appendChild(comment);

  return true;
}

}
