/***************************************************************************
                          compoundstring.cpp  -  description
                             -------------------
    begin                : Wed Sep 28 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "compoundstring.h"
#include "boolean.h"
#include "number.h"
#include "expr.h"
#include "context.h"

namespace limpid {

CompoundString::CompoundString() {}

Boolean CompoundString::getBoolean(Context& context) {
  return static_cast<int>(getString(context).size());
}

XPathString CompoundString::getString(Context& context) {
  DOMString resultString;
  size_t length = getLength();

  for (size_t index = 0; index < length; ++index)
    resultString += getItem(index).getString(context);

  return resultString;
}

Number CompoundString::getNumber(Context& context) {
  return Number(getString(context));
}

}

