/***************************************************************************
                          compoundstring.h  -  description
                             -------------------
    begin                : Wed Sep 28 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMPOUNDSTRING_H
#define COMPOUNDSTRING_H

#include "parentcomponent.h"
#include "xpathstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Expr;
  class Context;

  class CompoundString : public ParentComponent  {
  public:
  	CompoundString();

    bool isValid() { return true; }

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context);
    Number getNumber(Context& context);
    Expr eval(Context& context) { return getString(context); }

    CompoundString& copy() { return *(new CompoundString(*this)); }
  };
}

#endif
