/***************************************************************************
                          compoundtemplate.cpp  -  description
                             -------------------
    begin                : Thu Nov 11 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "compoundtemplate.h"

namespace limpid {

CompoundTemplate::CompoundTemplate() {}

XPathString CompoundTemplate::getString(XSLContext& parentContext) {
  XPathString returnString;

  size_t childCount = templateList_.getLength();
  for (size_t index = 0; index < childCount; ++index) {
    Template& tmp = templateList_.getItem(index);
    returnString += tmp.getString(parentContext);
  }

  return returnString;
}

Template& CompoundTemplate::getFirstTemplate() {
  if (templateList_.getLength())
    return templateList_.getItem(0);
  else
    return failTemplate;
}

Template& CompoundTemplate::getLastTemplate() {
  int length = templateList_.getLength();
  
  if (length)
    return templateList_.getItem(length - 1);
  else
    return failTemplate;
}

}
