/***************************************************************************
                          compoundtemplate.h  -  description
                             -------------------
    begin                : Thu Nov 11 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMPOUNDTEMPLATE_H
#define COMPOUNDTEMPLATE_H

#include "template.h"
#include "templatelist.h"
//#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class XSLContext;
  
  class CompoundTemplate : public Template  {
  public:
  	CompoundTemplate();

    bool process(XSLContext& parentContext) {
      return templateList_.process(parentContext); }
    bool processNode(XSLContext& parentContext, Node& node) {
      return templateList_.processNode(parentContext, node); }
    void addTemplate(Template& childTemplate) { templateList_.addTemplate(childTemplate); }
    size_t getLength() { return templateList_.getLength(); }
    Template& getTemplate(size_t index) { return templateList_.getItem(index); }
    Template& getFirstTemplate();
    Template& getLastTemplate();
    XPathString getString(XSLContext& parentContext);
    CompoundTemplate& copy() { return *(new CompoundTemplate(*this)); }

  private:
    TemplateList templateList_;
  };
}

#endif
