/***************************************************************************
                          configurationmanager.h  -  description
                             -------------------
    begin                : Tue Mar 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGURATIONMANAGER_H
#define CONFIGURATIONMANAGER_H

#include "configurationset.h"
#include "element.h"

/**
  *@author John Redmond
  */

namespace limpid {
class ConfigurationManager {
  public:
  	ConfigurationManager(Element& configureElement, bool setDefs);
    void configure(ConfigurationSet& configurationSet, bool useOutputElement);

  private:
    Element& configureElement_;
    bool setDefaults_;

    void configureOutput(ConfigurationSet& configurationSet);
    void setOutput(Element& outputElement, ConfigurationSet& configurationSet);
    void setDefaults(ConfigurationSet& configurationSet);
    void setKeys(ConfigurationSet& configurationSet);
    void setNamespaces(ConfigurationSet& configurationSet);
  };
}

#endif
