/***************************************************************************
                          configurationset.h  -  description
                             -------------------
    begin                : Tue Mar 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFIGURATIONSET_H
#define CONFIGURATIONSET_H

#include <set>
#include <map>
#include "domstring.h"
#include "keyspecs.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class XSLContext;
  class Document;
  class XSLResources;

  typedef std::map<DOMString, KeySpecs> KeyMap;
  typedef std::map<DOMString, DOMString> StringMap;
  typedef std::set<DOMString> CDATATypeSet;

  struct ConfigurationSet {
    enum OutputMode { XML = 0, HTML, TEXT, XHTML, OTHER };

    public:
    	ConfigurationSet() {}
      // Note that the names of these locals do not end with an underscore
      // as they are public.
      DOMString method, version, encoding, doctype_public, doctype_system;
      DOMString cdata_section_elements, media_type;
      bool omit_xml_declaration, standalone, indent;
      bool building, escape_text, escape_attributes;
      KeyMap keyMap;
      StringMap namespaceMap;
      CDATATypeSet cdataTypeSet;
  };
}

#endif
