/***************************************************************************
                          converter.h  -  description
                             -------------------
    begin                : Fri Apr 2 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONVERTER_H
#define CONVERTER_H

#include <climits>
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Converter {
  public:
  	Converter();

  static int maxInt;
  static int toInt(const DOMString& intString);
  static size_t toSize(const DOMString& sizeString) { return size_t(toInt(sizeString)); }
  static double toDouble(const DOMString& dString);
  static DOMString toString(int i);
  static DOMString toString(size_t i);
  static DOMString toString(long int i);
  static DOMString toString(unsigned long int i);
  static DOMString toString(double d);
  static DOMString toString(void *ptr);
  static DOMString toHexString(int i);
  static DOMString toHexString(size_t i);
  static DOMString toHexString(double d);
  static DOMString toHexString(const void *ptr);
  static bool toBoolean(DOMString s);
  static bool isNumber(const DOMString& token);
  };
}

/**
  Converter is a convenience class to localise static functions used to convert between
  DOMString and primitive data types, including int, size_t, double, void* and to
  convert DOMString and char* to boolean.
**/

#endif


