/***************************************************************************
                          copytemplate.h  -  description
                             -------------------
    begin                : Sun Jan 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COPYTEMPLATE_H
#define COPYTEMPLATE_H

#include "compoundtemplate.h"
#include "attributesettemplate.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class CopyTemplate : public Template  {
  public:
  	CopyTemplate(bool atStart, bool withChildren = false);

    bool process(XSLContext& parentTemplate);
    bool processNode(XSLContext& parentTemplate, Node& node);
    void addTemplate(Template& tmp);

    CopyTemplate& copy() { return *(new CopyTemplate(*this)); }

  private:
    CompoundTemplate attributes_, templates_;
    bool atStart_, withChildren_;
  };
}

#endif
