/***************************************************************************
 *   Copyright (C) 2007 by John Redmond   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDCSSWRITER_H
#define LIMPIDCSSWRITER_H

#include "dumper.h"
#include "writer.h"

namespace limpid {

/**
	@author John Redmond <john_redmond@optusnet.com.au>
*/
class CSSWriter : public Dumper
{
public:
    CSSWriter();
    CSSWriter(const DOMString& destString);
    CSSWriter(CharacterWriter& characterWriter);

    Node& process(Node& node);
    void flush() { if (writer_) writer_->flush(); }
    void update(const DOMString& destString);
    CSSWriter& copy() { return *(new CSSWriter(*this)); }

  private:
    Pointer<CharacterWriter> writer_;
    Node* blockedNode_;

    void processComment(Node& node);
    void processElement(Node& node);
    void processStyleStart(Node& node);
    void processEndNode(Node& node);
    void processAtStart(Node& node);
    void processAtEnd();
};

}

#endif
