/***************************************************************************
                          csvwriter.h  -  description
                             -------------------
    begin                : Tue Apr 11 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CSVWRITER_H
#define CSVWRITER_H

#include "dumper.h"
#include "writer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;
  class Element;
  class EndNode;
  class CharacterWriter;

  class CSVWriter : public Dumper  {
  public:
    CSVWriter(int separator = ',');
    CSVWriter(const DOMString& destName, int separator = ',');
    CSVWriter(CharacterWriter& characterWriter, int separator = ',');

    Node& process(Node& node);
    void flush() { if (writer_) writer_->flush(); }
    void update(const DOMString& destString);
    CSVWriter& copy() { return *(new CSVWriter(*this)); }

  private:
    Pointer<CharacterWriter> writer_;
    Char separator_;
  };
}

#endif
