/***************************************************************************
                          currentcollector.h  -  description
                             -------------------
    begin                : Thu Apr 28 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CURRENTCOLLECTOR_H
#define CURRENTCOLLECTOR_H

#include <vector>
#include "nodesetprocessor.h"
#include "context.h"
#include "xpathexpression.h"
#include "domstring.h"
#include "node.h"
#include "xpathstring.h"
#include "boolean.h"
#include "number.h"
#include "nodeset.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class CurrentCollector: public NodeSetProcessor {
  public:
  	CurrentCollector();
    CurrentCollector(XPathExpression& comp);

    Boolean getBoolean(Context&) { return true; }
    XPathString getString(Context& context);
    Number getNumber(Context&) { return 1; }
    NodeSet getNodeSet(Context& context, bool exact = true);
    Expr eval(Context& context) { return getNodeSet(context); }

    NodeSet processNodeSet(NodeSet& nodeSet, Context& context, bool exact = true);
    CurrentCollector& copy() { return *(new CurrentCollector(*this)); }

  private:
    size_t *refCount;
 };
}

#endif
