/***************************************************************************
                          cutter.h  -  description
                             -------------------
    begin                : Thu Jul 8 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CUTTER_H
#define CUTTER_H

#include "documentprocessor.h"
#include "document.h"
#include "matcher.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Cutter: public DocumentProcessor  {
  public:
    Cutter(const DOMString& matchString, bool discardChildren = false);

    Document& processDocument(Document& document);
    Cutter& copy() { return *(new Cutter(*this)); }

  private:
    Matcher matcher_;
    bool discardChildren_;

    void copyChildren(Node& targetNode);
  };
}

#endif
