/***************************************************************************
                          decimalformat.h  -  description
                             -------------------
    begin                : Fri Apr 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DECIMALFORMAT_H
#define DECIMALFORMAT_H

#include "domstring.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class Node;

  class DecimalFormat {
  public:
  	DecimalFormat(const DOMString& decimalSeparatorx = '.',
        const DOMString& groupingSeparatorx = ',',
        const DOMString& infinityx = "Infinity", const DOMString& minusSignx = '-',
        const DOMString& nanx = "NaN", const DOMString& percentx = "o/o",
        const DOMString& permillex = "o/oo", const DOMString& zeroDigitx = '0',
        const DOMString& digitx = '#', const DOMString& patternSeparatorx = ';');

     DOMString decimalSeparator, groupingSeparator, infinity,  minusSign;
     DOMString nan, percent, permille, zeroDigit, digit, patternSeparator;

     void update(Node& parentNode);

   private:
     void doUpdate(DOMString& name, DOMString& value);
  };
}

#endif
