/***************************************************************************
                          decimalformatmap.cpp  -  description
                             -------------------
    begin                : Mon May 2 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "decimalformatmap.h"

namespace limpid {

DecimalFormatMap::DecimalFormatMap() {
}

void DecimalFormatMap::setFormat(const DOMString& key, const DecimalFormat& format) {
  FormatMap::iterator p = formatMap_->find(key);
  if (p != formatMap_->end())
    formatMap_->erase(p);
  formatMap_->insert(make_pair(key, Pointer<DecimalFormat>(new DecimalFormat(format))));
}

DecimalFormat& DecimalFormatMap::getFormat(const DOMString& key) const {
  static DecimalFormat defaultFormat;

  FormatMap::iterator p = formatMap_->find(key);
  if (p != formatMap_->end())
    return *(p->second);
  else
    return defaultFormat; // defaultMap
}

}
