/***************************************************************************
                          decimalformatmap.h  -  description
                             -------------------
    begin                : Mon May 2 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DECIMALFORMATMAP_H
#define DECIMALFORMATMAP_H

#include <map>
#include "domstring.h"
#include "decimalformat.h"
#include "pointer.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class DecimalFormatMap {
  public:
  	DecimalFormatMap();

    void setFormat(const DOMString& key, const DecimalFormat& format);
    DecimalFormat& getFormat(const DOMString& key) const;

  private:
    typedef std::map<DOMString, Pointer<DecimalFormat> > FormatMap;

    Pointer<FormatMap> formatMap_;
  };
}


#endif
