/***************************************************************************
                          decimalformatter.h  -  description
                             -------------------
    begin                : Mon May 2 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DECIMALFORMATTER_H
#define DECIMALFORMATTER_H

#include "domstring.h"
#include "decimalformat.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DecimalFormat;

  class DecimalFormatter {
  public:
  	DecimalFormatter(const DOMString& formatString);

    DOMString format(double number);
    DOMString format(double number, const DecimalFormat& decimalFormat);

  private:
    DecimalFormat format_;
    size_t leftWidth_, rightWidth_;
    bool isNegative_;

    DOMString getIntegerString(double integer);
    DOMString getRealString(double number);
    DOMString getSimpleString(double integer);

    double forceRounding(double value);

    DOMString formatSimpleString(const DOMString& simpleString, size_t width, bool atStart);
    DOMString separateGroups(const DOMString& numberString);

    void configure(const DOMString& formatString);
};

}

#endif
