/***************************************************************************
                          documentbox.h  -  description
                             -------------------
    begin                : Wed Mar 8 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTBOX_H
#define DOCUMENTBOX_H

#include <vector>
#include "documentsource.h"
#include "documentprocessor.h"
#include "writer.h"

/**
  *@author John Redmond
  */

namespace limpid {  
  class DocumentBox : public DocumentProcessor  {
    public:
      DocumentBox();
      DocumentBox(DocumentSource& documentSource);

      Document& processDocument(Document& inputDocument);
      void process();
      void update(const DOMString& destString);
      void start();
      void finish();

      void setSource(DocumentSource& documentSource) {
        documentSource_ = &documentSource.copy();
      }
      void addProcessor(DocumentProcessor& documentProcessor) {
        processors_->push_back(&documentProcessor.copy());
      }
      DocumentBox& copy() { return *(new DocumentBox(*this)); }

    private:
      typedef Pointer<DocumentProcessor> ProcessorPointer;
      typedef std::vector<ProcessorPointer> Processors;

      Pointer<DocumentSource> documentSource_;
      Pointer<Processors> processors_;
  };
}

#endif
