/***************************************************************************
                          documentcontent.h  -  description
                             -------------------
    begin                : Fri Sep 12 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTCONTENT_H
#define DOCUMENTCONTENT_H

#include "parentcontent.h"

class Document;
class Element;
class XMLDeclaration;
class DocumentType;
class ValidationProcessor;
/**
  *@author John Redmond
  */

namespace limpid {
  class Document;
  class Element;
  class DocumentType;
  class ValidationProcessor;

  class DocumentContent : public ParentContent  {
    public:
    DocumentContent(ParentNode& parent);
    DocumentContent(const DOMString& uri, const DOMString& name, ParentNode& parent);
    ~DocumentContent();

    size_t getSize();

    Document *controlDocument_;
    XMLDeclaration *xmlDeclaration_;
    Element *documentElement_;
    Node *cachedNode_;
    DocumentType *doctype_;
    Char *namespaceURI_;
  };
}
#endif
