/***************************************************************************
                          documentmerger.h  -  description
                             -------------------
    begin                : Sun Feb 6 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTMERGER_H
#define DOCUMENTMERGER_H

#include "document.h"
#include "nodelist.h"

/**
  DocumentMerger merges one or more stylesheet documents into one.

  *@author John Redmond
  */

namespace limpid {

  class URL;

  class DocumentMerger {
  public:
  	DocumentMerger(bool includeWhitespace = true);

    Document getDocument(const URL& url);
    Document getDocument(const DOMString& urlString);

  private:
    bool includeWhitespace_;

    Document getMergedDocument(const URL& url);
    Document doMerges(Document& parentDocument, const URL& parentURL, bool doIncludes);
    void mergeInclude(Node& refNode, Document& mergedDocument);
    void mergeImport(Node& refNode, Document& mergedDocument);
    NodeList collectByName(Document& parentDocument, DOMString& nodeName);
    void mergeContent(NodeList& matchList, const URL& parentURL, bool doInclude);
    void removeNode(Node& node);
  };
}

#endif
