/***************************************************************************
                          documenttemplate.h  -  description
                             -------------------
    begin                : Thu Apr 21 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTTEMPLATE_H
#define DOCUMENTTEMPLATE_H

#include "template.h"
#include "domstring.h"
#include "document.h"
#include "expr.h"
#include "reader.h"
#include "xslresources.h"
#include "xslcontext.h"
#include "defaulttemplate.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class URL;
  class Node;

  class DocumentTemplate : public Template  {
    public:
    	DocumentTemplate(const DOMString& matchValue, const DOMString& defaultBase);

      bool process(XSLContext& parentContext);
      bool processNode(XSLContext& parentContext, Node& node);
      void setResources(XSLResources& resources);
      DocumentTemplate& copy() { return *(new DocumentTemplate(*this)); }

    private:
      DOMString defaultBase_;
      Expr firstExpr_, secondExpr_;
      XSLContext context_;
      XSLResources resources_;
      DefaultTemplate defaultTemplate_;
      bool multi_, relative_;

      void configure(const DOMString& matchValue);
      void processOne(XSLContext& parentContext);
      void processTwo(XSLContext& parentContext);
      void processMulti(XSLContext& parentContext);
      void processDocument(const Reader& reader, const DOMString& pathString);

      URL getURL(const DOMString& partString, XSLContext& parentContext);
      DOMString getBaseURLString(const Node& node);
      Reader getReader(const DOMString& partString, XSLContext& context);
      Reader getReader(const DOMString& basePath, const DOMString& relPath);
      Document getDocument(const Reader& reader);
      DOMString getFullPath(const DOMString& basePath, const DOMString& relPath);
  };
}

#endif
