/***************************************************************************
                          documenttypecontent.cpp  -  description
                             -------------------
    begin                : Fri Sep 12 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "documenttypecontent.h"

namespace limpid {

DocumentTypeContent::DocumentTypeContent(const DOMString& name, const DOMString& pubId, const DOMString& sysId):
      NamedContent(Node::DOCUMENT_TYPE_NODE, name),
      publicId_(pubId.copyChars()), systemId_(sysId.copyChars()),
      internalSubset_(0), controlElement_(new Element("controller")),
      sourceURL_(0), entities_(new NamedNodeMap(*controlElement_)),
      unparsedEntities_(new NamedNodeMap(*controlElement_)),
      notations_(new NamedNodeMap(*controlElement_)),
      entityMap_(new StringMap), idMap_(new StringMap),
      /*validationProcessor_(new ValidationProcessor),*/ constrained_(false) {
}

DocumentTypeContent::~DocumentTypeContent() {
  deleteContent();
}

size_t DocumentTypeContent::getSize() {   // this is not accurate
  size_t size = sizeof(*this);
/*
  if (prefix_) size += (DOMString::strLength(prefix_) + 1) * sizeof(Char);
  size += (DOMString::strLength(nodeName_) + 1) * sizeof(Char);
  if (publicId_) size += (DOMString::strLength(publicId_) + 1) * sizeof(Char);
  if (systemId_) size += (DOMString::strLength(systemId_) + 1) * sizeof(Char);
  if (internalSubset_) size += (DOMString::strLength(internalSubset_) + 1) * sizeof(Char);
  size += entities_->getSize();
  size += unparsedEntities_->getSize();
  size += notations_->getSize();
  size += sizeof(*entityMap_);
  size += sizeof(*idMap_);
  if (validationProcessor_) size += validationProcessor_->getSize();
*/
  return size;
}

void DocumentTypeContent::deleteContent() {
  delete [] publicId_;
  delete [] systemId_;
  delete [] internalSubset_;
  delete controlElement_;
  delete sourceURL_;
  delete entities_;
  delete unparsedEntities_;
  delete notations_;
  delete entityMap_;
  delete idMap_;
//  delete validationProcessor_;
}

}
