/***************************************************************************
                          documenttypecontent.h  -  description
                             -------------------
    begin                : Fri Sep 12 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTTYPECONTENT_H
#define DOCUMENTTYPECONTENT_H

#include "nodecontent.h"
#include "element.h"
#include "domstring.h"
#include "namednodemap.h"
#include "url.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;
  typedef std::map<DOMString, DOMString> StringMap;

  class DocumentTypeContent : public NamedContent  {
  public:
  	DocumentTypeContent(const DOMString& name,
        const DOMString& pubID, const DOMString& sysID);
  	~DocumentTypeContent();
    Char *publicId_, *systemId_, *internalSubset_;
    Element *controlElement_;
    URL *sourceURL_;
    NamedNodeMap *entities_, *unparsedEntities_, *notations_;
    StringMap *entityMap_, *idMap_;
    bool constrained_;

    size_t getSize();

   protected:
    void deleteContent();
  };
}
#endif
