/***************************************************************************
                          documentwritertemplate.cpp  -  description
                             -------------------
    begin                : Tue Oct 18 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "documentwritertemplate.h"
#include "configurationmanager.h"
#include "outputmanager.h"

namespace limpid {

DocumentWriterTemplate::DocumentWriterTemplate(const DOMString& destString,
      ConfigurationSet& configurationSet):
    Template(destString), configurationSet_(configurationSet) {}

void DocumentWriterTemplate::configure(Element& configureElement) {
  ConfigurationManager(configureElement, false).configure(configurationSet_, false);
}

bool DocumentWriterTemplate::process(XSLContext& parentContext) {
  XSLContext context;
  context.setParent(parentContext);

  OutputManager().setWriter(context, matchValue_, configurationSet_);

  return templates_.process(context);
}

bool DocumentWriterTemplate::processNode(XSLContext& parentContext, Node& node) {
  XSLContext context;
  context.setParent(parentContext);

  OutputManager().setWriter(context, matchValue_, configurationSet_);

  return templates_.processNode(parentContext, node);
}

}
