/***************************************************************************
                          documentwritertemplate.h  -  description
                             -------------------
    begin                : Tue Oct 18 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTWRITERTEMPLATE_H
#define DOCUMENTWRITERTEMPLATE_H

#include "compoundtemplate.h"
#include "configurationset.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;

  class DocumentWriterTemplate : public Template  {
  public:
  	DocumentWriterTemplate(const DOMString& destString, ConfigurationSet& configurationSet);
    void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    size_t getLength() { return templates_.getLength(); }
    DocumentWriterTemplate& copy() { return *(new DocumentWriterTemplate(*this)); }

  private:
    CompoundTemplate templates_;
    ConfigurationSet configurationSet_;

    void configure(Element& configureElement);
  };
}


#endif
