/***************************************************************************
                          dombuilder.h  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOMBUILDER_H
#define DOMBUILDER_H

#include "domstring.h"
#include "document.h"
#include "reader.h"
#include "writer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class URL;
  class DOMBuilder {
  public:
    explicit DOMBuilder(const URL& url, bool checkBalance = false);
    DOMBuilder(const CharacterReader &reader, bool checkBalance = false);
    DOMBuilder(const DOMString& source, bool checkBalance = false);

    Document build();
    void setProcessingXSLT(bool flag) { processingXSLT_ = flag; }
    void setTrimmingText(bool flag) { trimmingText_ = flag; }
    void setNormalizingWhitespace(bool flag) { normalizingWhitespace_ = flag; }
    void setVerbose(bool verbose) { verbose_ = verbose; }

  protected:
    Pointer<CharacterReader> reader_;
    bool verbose_;

  private:
    URL url_;
    bool processingXSLT_, trimmingText_, normalizingWhitespace_,
      checkingBalance_;
  };
}
#endif
