/***************************************************************************
                          domexception.cpp  -  description
                             -------------------
    begin                : Mon Nov 17 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "domexception.h"

namespace limpid {

DOMException::DOMException(int code, const DOMString& message, int lineNo):
      code_(code), lineNo_(lineNo), message_(message) {
}

DOMException::~DOMException() {
}

DOMString DOMException::getMessage() {
  DOMString message;
  message += toString(code_);
  message += ": DOM exception: ";
  message +=  message_;
  if (lineNo_ != -1)
    message += toString(lineNo_);
  message += '\n';

  return message;
}

}
