/***************************************************************************
                          domexception.h  -  description
                             -------------------
    begin                : Mon Nov 17 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOMEXCEPTION_H
#define DOMEXCEPTION_H

#include "domstring.h"
#include "converter.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMException: protected Converter {
  public:
    enum Code {INDEX_SIZE_ERR = 1, DOMSTRING_SIZE_ERR, HIERARCHY_REQUEST_ERR,
                WRONG_DOCUMENT_ERR, INVALID_CHARACTER_ERR, NO_DATA_ALLOWED_ERR,
                NO_MODIFICATION_ALLOWED_ERR, NOT_FOUND_ERR, NOT_SUPPORTED_ERR,
                INUSE_ATTRIBUTE_ERR, IO_ERR };
  	DOMException(int code, const DOMString& message, int lineNo = -1);
  	~DOMException();
    int getCode() const { return code_; }
    int getLineNo() { return lineNo_; }
    DOMString getMessage();

  private:
    int code_, lineNo_;
    DOMString message_;
  };
}
#endif
