/***************************************************************************
                          domimplementation.cpp  -  description
                             -------------------
    begin                : Sat Apr 3 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "domimplementation.h"
#include "document.h"
#include "documenttype.h"

namespace limpid {

DOMImplementation::DOMImplementation() {
}

DOMImplementation::~DOMImplementation(){
}

DOMImplementation& DOMImplementation::getImplementation() {
  static DOMImplementation implementation;
  return implementation;
}

bool DOMImplementation::hasFeature(const DOMString& feature, const DOMString& version) {
  DOMString fs = feature;
  DOMString vs = version;
  bool featureMatched = fs == "core";
  bool versionMatched = vs == "1.0" || vs == "2.0";

  return featureMatched && versionMatched;
}

DocumentType DOMImplementation::createDocumentType(const DOMString& qualifiedName,
      const DOMString& publicId, const DOMString& systemId) {
  DocumentType doctype(qualifiedName, publicId, systemId);

  return doctype;
}

Document DOMImplementation::createDocument(const DOMString& namespaceURI,
      const DOMString& qualifiedName, DocumentType& doctype) {
   Document document(namespaceURI, qualifiedName);
   document.appendChild(doctype);

   return document;
}

}
