/***************************************************************************
                          domimplementation.h  -  description
                             -------------------
    begin                : Sat Apr 3 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOMIMPLEMENTATION_H
#define DOMIMPLEMENTATION_H


/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;
  class DocumentType;
  class Document;

  class DOMImplementation {
  public:
  	DOMImplementation();
  	~DOMImplementation();

  static DOMImplementation& getImplementation();
  bool hasFeature(const DOMString& feature, const DOMString& version);
  DocumentType createDocumentType(const DOMString& qualifiedName, const DOMString& publidId,
                                    const DOMString& systemId);
  Document createDocument(const DOMString& namespaceURI, const DOMString& qualifiedName,
                                    DocumentType& doctype);
  };
}
#endif
