/***************************************************************************
                          domwriter.cpp  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "domwriter.h"
#include "traverser.h"
//#include "htmlwriter.h"

namespace limpid {

DOMWriter::DOMWriter(bool isHTML): xmlWriter_(new XMLWriter(isHTML)) {}

DOMWriter::DOMWriter(XMLWriter& xmlWriter):
    xmlWriter_(&xmlWriter.copy()) {}
    
DOMWriter::DOMWriter(CharacterWriter& writer, bool isHTML):
    xmlWriter_(new XMLWriter(writer, isHTML)) {}

DOMWriter::DOMWriter(const URL& url, bool isHTML):
    xmlWriter_(new XMLWriter(url, isHTML)) {}

void DOMWriter::write(Node& root) {
  // use a traverser that processes end nodes, but does not
  // invoke begin() and end() on its processor
  Traverser traverser(*xmlWriter_, true, false);
  traverser.process(root);
}

void DOMWriter::setFormat(const DOMString& nl, const DOMString& i, const DOMString& ai) {
  xmlWriter_->setFormat(nl, i, ai);
}

void DOMWriter::setStartAndFinish(const DOMString& start, const DOMString& finish) {
  xmlWriter_->setStartAndFinish(start, finish);
}

}
