/***************************************************************************
                          domwriter.h  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOMWRITER_H
#define DOMWRITER_H

#include <iostream>
#include "domutils.h"
#include "node.h"
#include "domstring.h"
#include "xmlwriter.h"
#include "pointer.h"
#include "value.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class URL;

  class DOMWriter: public DOMUtils {
  public:
  	DOMWriter(bool isHTML = false);
    DOMWriter(XMLWriter& writer);
    DOMWriter(CharacterWriter& writer, bool isHTML = false);  // use this if you want to set the encoding
    DOMWriter(const URL& url, bool isHTML = false);

    void write(Node& root);
    void setFormat(const DOMString& nl, const DOMString& i, const DOMString& ai);
    void setStartAndFinish(const DOMString& start, const DOMString& finish);
    void setFormatting(bool flag) { xmlWriter_->setFormatting(flag); }

  private:
    Pointer<XMLWriter> xmlWriter_;
  };
}
#endif
