/***************************************************************************
                          dtdgetter.cpp  -  description
                             -------------------
    begin                : Fri Jun 2 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dtdgetter.h"
#include "parser.h"
#include "element.h"
#include "reader.h"
#include "writer.h"
#include "domwriter.h"

namespace limpid {

DTDGetter::DTDGetter(const DOMString& sourceString){
    Reader reader(sourceString);
    converter_ = new DTDConverter(reader);
}

Document& DTDGetter::getDocument() {
  if (converter_) {
    converter_->process();
    document_ = converter_->getDocument();
  }

  return document_;
}

}
