/***************************************************************************
                          elementcontent.cpp  -  description
                             -------------------
    begin                : Wed Sep 10 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "elementcontent.h"

namespace limpid {

ElementContent::ElementContent(const DOMString& name, ParentNode& parent):
  ParentContent(Node::ELEMENT_NODE, name, parent) {
  attributes_ = 0;
}

ElementContent::~ElementContent() {
  delete attributes_;
}

size_t ElementContent::getSize() {  // this includes the attrs
  size_t size = sizeof(*this);

  if (prefix_) size += (DOMString::strLength(prefix_) + 1) * sizeof(Char);
  size += (DOMString::strLength(nodeName_) + 1) * sizeof(Char);
  if (childNodes_) size += childNodes_->getSize(); // children not included
  if (attributes_) size += attributes_->getSize(); // attrs are included

  return size;
}

}
