/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "elementpoint.h"
//#include "writer.h

namespace limpid {

ElementPoint::ElementPoint(const DOMString& name): MatchPoint(name, true) {
 minHits_ = 1;
 maxHits_ = 1;
 type_ = ELEMENT;
}

ElementPoint::ElementPoint(const Element& element): MatchPoint("temp", true) {
  setFrequency(element);
  name_ = element.getAttribute("name");
  if (name_.empty())
    name_ = element.getAttribute("type");
  type_ = ELEMENT;
}

void ElementPoint::traverse(const DOMString& indent) {
  DOMString newIndent = indent;
  newIndent += "  ";
wrt::Console << newIndent << "ELEMENT " << name_ << " Max " << maxHits_ << " Min " << 
minHits_ << wrt::endl;
}

}
