/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDELEMENTPOINT_H
#define LIMPIDELEMENTPOINT_H

#include "matchpoint.h"
#include "domstring.h"
#include "element.h"

namespace limpid {

/**
	@author John Redmond <john_redmond@optusnet.com.au>
*/
class ElementPoint : public MatchPoint
{
public:
  ElementPoint(const DOMString& name);
  ElementPoint(const Element& element);
  
  bool test(Node& node) { return node.getNodeName() == name_; }
  void traverse(const DOMString& indent);
  MatchPoint& getActivePoint() { return *this; }
  virtual ElementPoint& copy() { return *(new ElementPoint(*this)); }


};

}

#endif
