/***************************************************************************
                          endnode.h  -  description
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ENDNODE_H
#define ENDNODE_H

#include "node.h"
#include "parentnode.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class EndNode : public ParentNode  {
  public:
    EndNode();
  	EndNode(const DOMString& name);
    EndNode(const EndNode& refNode);
    EndNode& operator=(const EndNode& refNode);

    void update(Node& refNode);
    Node& getStartNode();

    Node& cloneNode(bool) { return copy(); }
    bool isValid() const { return true; }
    bool hasNonTextChildren() const;
    DOMString getDisplayString() const;

  private:
    EndNode& copy() { return *(new EndNode(getNodeName())); }

  };
}
#endif
