/***************************************************************************
                          entity.cpp  -  description
                             -------------------
    begin                : Wed Sep 24 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "entity.h"
#include "entitycontent.h"
#include "writer.h"

namespace limpid {

Entity::Entity(const DOMString& name, const DOMString& pubId,
      const DOMString& sysId, const DOMString& notName) {
  try {
    nodeContent_ = new EntityContent(name, pubId, sysId, notName, *this);
  }
  catch (std::bad_alloc) {
    delete nodeContent_;
    throw;
  }
}
/*
Entity::Entity(const Entity& refEntity): ParentNode(refEntity) {
}

Entity& Entity::operator=(const Entity& refEntity) {
  replaceContent(refEntity);
  return *this;
}
*/
/*
DOMString Entity::getNodeName() {
  EntityContent *contentPtr = static_cast<EntityContent *>(nodeContent_);
  if (contentPtr->nodeName_) return contentPtr->nodeName_;
  else return "";
}
*/
DOMString Entity::getPublicId() {
  EntityContent *contentPtr = static_cast<EntityContent *>(nodeContent_);
  if (contentPtr->publicId_) return contentPtr->publicId_;
  else return "";
}

DOMString Entity::getSystemId() {
  EntityContent *contentPtr = static_cast<EntityContent *>(nodeContent_);
  if (contentPtr->systemId_) return contentPtr->systemId_;
  else return "";
}

DOMString Entity::getNotationName() {
  EntityContent *contentPtr = static_cast<EntityContent *>(nodeContent_);
  if (contentPtr->notationName_) return contentPtr->notationName_;
  else return "";
}

}
