/***************************************************************************
                          entitywriter.cpp  -  description
                             -------------------
    begin                : Mon Sep 6 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "entitywriter.h"

using namespace std;

namespace limpid {

EntityWriter::EntityWriter(): Writer() {}

EntityWriter::EntityWriter(URL& url, Encoding encoding):
    Writer(url, encoding) {
  writeDeclaration(encoding);
}

void EntityWriter::writeDeclaration(Encoding encoding) {
  DOMString encodingString = IOBase::getEncodingString(encoding);
  if (!encodingString.size()) return; // no declaration

  *this << "<?xml encoding=\"" << encodingString << "\"?>";

  setEncoding(encoding);
}

}
