/***************************************************************************
                          expr.h  -  description
                             -------------------
    begin                : Fri Nov 19 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXPR_H
#define EXPR_H

#include "xpathexpression.h"
#include "nodeset.h"
#include "boolean.h"
#include "number.h"
#include "xpathstring.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Context;
  
  class Expr {
  public:
    Expr();
  	Expr(const XPathExpression& expression);

   XPathString getString(Context& ctxt) const { return xpathExpression_->getString(ctxt); }
   Boolean getBoolean(Context& ctxt) const { return xpathExpression_->getBoolean(ctxt); }
   Number getNumber(Context& ctxt) const { return xpathExpression_->getNumber(ctxt); }
   NodeSet getNodeSet(Context& ctxt, bool exact = true) const {
      return xpathExpression_->getNodeSet(ctxt, exact);   }
   double getPriority() const { return xpathExpression_->getPriority(); }
   bool isValid() { return xpathExpression_->isValid(); }
   bool isNodeSet() { return xpathExpression_->isNodeSet(); }
   bool isBoolean() { return xpathExpression_->isBoolean(); }

   XPathExpression& getContent() { return *xpathExpression_; }
   Expr eval(Context& context) const { return xpathExpression_->eval(context); };
   Expr& copy() { return *(new Expr(*xpathExpression_)); }

  private:
    Pointer<XPathExpression> xpathExpression_;
  };
}

#endif

