/***************************************************************************
                          expressionmap.cpp  -  description
                             -------------------
    begin                : Sat Sep 17 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "expressionmap.h"

namespace limpid {

ExpressionMap::ExpressionMap(): exprMap_(new ExprMap) {}

void ExpressionMap::setExpr(const DOMString& key, const Expr& expr) {
  exprMap_->insert(make_pair(key, expr));
}

bool ExpressionMap::hasExpr(const DOMString& key) const {
  return exprMap_->find(key) != exprMap_->end();
}

DOMString ExpressionMap::getKey(size_t index) const {
  if (index >= exprMap_->size()) return "";
  ExprMap::iterator p = exprMap_->begin();
  advance(p, index);
  return p->first;
}

Expr ExpressionMap::getExpr(size_t index) const {
  if (index >= exprMap_->size()) return Expr();
  ExprMap::iterator p = exprMap_->begin();
  advance(p, index);
  return p->second;
}

Expr ExpressionMap::getExpr(const DOMString& key) const {
  ExprMap::iterator p = exprMap_->find(key);
  if (p != exprMap_->end()) return p->second;
  else return Expr();
}

}
