/***************************************************************************
                          expressionmap.h  -  description
                             -------------------
    begin                : Sat Sep 17 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXPRESSIONMAP_H
#define EXPRESSIONMAP_H

#include <map>
#include "domstring.h"
#include "expr.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class ExpressionMap {
  public:
  	ExpressionMap();

    void setExpr(const DOMString& key, const Expr& expr);
    bool hasExpr (const DOMString& key) const;
    DOMString getKey(size_t index) const;
    Expr getExpr(size_t index) const;
    Expr getExpr(const DOMString& key) const;
    size_t getLength() const { return exprMap_->size(); }
    void clear() { exprMap_->clear(); }

  private:
    typedef std::map<DOMString, Expr> ExprMap;

    Pointer<ExprMap> exprMap_;

  };
}

#endif
