/***************************************************************************
                          extractor.h  -  description
                             -------------------
    begin                : Sun Jun 11 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXTRACTOR_H
#define EXTRACTOR_H

#include "documentprocessor.h"
#include "stylesheet.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid  {
  class DOMString;

  class Extractor: public DocumentProcessor  {
  public:
    Extractor(const DOMString& rootName = "ROOT");

    Document& processDocument(Document& inputDocument);
    void update(const DOMString&) {}
    Extractor& copy() { return *(new Extractor(*this)); }

  private:
    DOMString rootName_;
    Document document_;

    DOMString getTagName(Node& node);
    bool hasTag(Node& node);
  };
}

#endif
