/***************************************************************************
                          finder.cpp  -  description
                             -------------------
    begin                : Mon Jan 26 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "finder.h"
#include "domwriter.h"
#include "dombuilder.h"
#include "nodeset.h"
#include "xpathfactory.h"
#include "context.h"

namespace limpid {

Finder::Finder(const DOMString& src) {
  DOMBuilder builder(src);
  document_ = builder.build();
}

NodeSet Finder::find(const DOMString& src) {
  Context context;
  context.setNode(document_);
  Expr expr = XPathFactory().getExpr(src);
  nodeSet_ = expr.getNodeSet(context);
  return nodeSet_;
}

void Finder::display() {
  size_t length = nodeSet_.getLength();
  if (!length) return;

  DOMWriter outputter;
  for (size_t index = 0; index < length; ++index)
    outputter.write(nodeSet_.item(index));
}

}
