/***************************************************************************
                          followingstream.h  -  description
                             -------------------
    begin                : Wed May 26 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FOLLOWINGSTREAM_H
#define FOLLOWINGSTREAM_H

#include "nodesource.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class FollowingStream : public NodeSource  {
  public:
    FollowingStream(bool forward = true);
  	FollowingStream(const Node& root, bool forward = true);

    Node& nextNode();
    void setIncludeChildren(bool includeChildren) { includeChildren_ = includeChildren; }
    void setRoot(const Node& root);
    FollowingStream& copy() { return *(new FollowingStream(*this)); }

  private:
    bool forward_, includeChildren_;
    Node *refNode_;

    Node& getNext();
    Node& getNodePreceding(Node& refNode);
    Node& getNodeFollowing(Node& refNode);
    void reset();
  };
}

#endif
