/***************************************************************************
                          foreachtemplate.cpp  -  description
                             -------------------
    begin                : Fri Oct 22 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "foreachtemplate.h"
#include "xpathfactory.h"
#include "domwriter.h"

namespace limpid {

ForEachTemplate::ForEachTemplate(DOMString& selectString): Template(selectString),
      expr_(XPathFactory::getExpr(selectString)) {}

bool ForEachTemplate::process(XSLContext& parentContext) {
  parentContext.updateCurrentNode();
  NodeSet resultSet = expr_.getNodeSet(parentContext);

  XSLContext context;
  context.setParent(parentContext);
  context.setNode(parentContext.getNode());
  context.setCurrentSet(resultSet);

  sortTemplates_.process(context);

//  size_t count = resultSet.getLength();
//  context.setCount(count);

  for (size_t index = 0; index < resultSet.getLength(); ++index) {
    context.setNode(resultSet.item(index));
    context.setPosition(index + 1);
    templates_.process(context);
  }

  return true;
}

bool ForEachTemplate::processNode(XSLContext& parentContext, Node& node) {
  parentContext.updateCurrentNode();
  XSLContext context;
  NodeSet resultSet = expr_.getNodeSet(parentContext);

  context.setParent(parentContext);
  context.setNode(parentContext.getNode());
  context.setCurrentSet(resultSet);

  sortTemplates_.process(context);

  size_t count = resultSet.getLength();
  context.setCount(count);

  for (size_t index = 0; index < count; ++index) {
    context.setNode(resultSet.item(index));
    context.setPosition(index + 1);
    templates_.processNode(context, node);
  }

  return true;
}

}
