/***************************************************************************
                          foreachtemplate.h  -  description
                             -------------------
    begin                : Fri Oct 22 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FOREACHTEMPLATE_H
#define FOREACHTEMPLATE_H

#include "template.h"
#include "compoundtemplate.h"
#include "expressionsorter.h"
#include "expr.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class ForEachTemplate : public Template  {
  public:
  	ForEachTemplate(DOMString& selectString);

    void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }
    void addSortTemplate(Template& childTemplate) { sortTemplates_.addTemplate(childTemplate); }
    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    ForEachTemplate& copy() { return *(new ForEachTemplate(*this)); }

  private:
    Expr expr_;
    CompoundTemplate templates_, sortTemplates_;
  };
}

#endif
