/***************************************************************************
                          generalcomparison.h  -  description
                             -------------------
    begin                : Thu Sep 15 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENERALCOMPARISON_H
#define GENERALCOMPARISON_H

#include "parentcomponent.h"
#include "xpathstring.h"
#include "boolean.h"
#include "number.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;
  class XPathString;
  class Boolean;
  class Context;

  class GeneralComparison : public ParentComponent  {
  public:
  	GeneralComparison();
    GeneralComparison(const DOMString& typeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    GeneralComparison& copy() { return *(new GeneralComparison(*this)); }

  protected:
    bool logic_;

    bool comparePair(XPathExpression& first, XPathExpression& second, Context& context);
    bool compareOneNodeSet(const NodeSet& nodeSet,
        const XPathExpression& secondExpression, Context& context);
    bool compareNodeSets(const NodeSet& firstSet, const NodeSet& secondSet);
    bool matchSet(const NodeSet& nodeSet, const XPathString& testString);
    bool compareStrings(const DOMString& firstString, const DOMString& secondString) {
      return firstString == secondString; }
    bool compareNodes(const Node& firstNode, const Node& secondNode) {
      return firstNode == secondNode; }
  };
}

#endif
