/***************************************************************************
                          getter.cpp  -  description
                             -------------------
    begin                : Tue Apr 11 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "getter.h"
#include "parser.h"
#include "reformer.h"

namespace limpid {

Getter::Getter(Parser& parser, bool hasText):
  builder_(new Builder), parser_(&parser.copy()), hasText_(hasText) {}

Document& Getter::getDocument() {
  if (parser_) {
    while (true) {
      Node& node = parser_->nextNode();
      if (!node.isValid()) break;

      builder_->process(node);
    }
  }

  Document& document = builder_->getDocument();

  if (hasText_)
    Reformer().processDocument(document);

  return document;
}

}
