/***************************************************************************
                          getter.h  -  description
                             -------------------
    begin                : Tue Apr 11 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GETTER_H
#define GETTER_H

#include "documentsource.h"
#include "document.h"
#include "builder.h"
#include "parser.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Getter : public DocumentSource  {
  public:
    Getter() {} // just a place filler
    Getter(Parser& parser, bool hasText = false);
    void setCheckBalance(bool checkBalance) { builder_->setCheckBalance(checkBalance); }

    Document& getDocument();
    Getter& copy() { return *(new Getter(*this)); }

  private:
    Pointer<Builder> builder_;
    Pointer<Parser> parser_;
    bool hasText_;
  };
}


#endif
