/***************************************************************************
                          groupcomponent.cpp  -  description
                             -------------------
    begin                : Fri May 21 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "groupcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

namespace limpid {

GroupComponent::GroupComponent(GroupType type): type_(type){
}

Boolean GroupComponent::getBoolean(Context& context) {
  size_t componentCount = components->size();
  if (!componentCount) return false; // this is a real error

  if (componentCount == 1)
      return (*components->begin())->getBoolean(context); // this should not happen

  for (ComponentList::iterator p = components->begin();
    p != components->end(); p++) {
      bool result = (*p)->getBoolean(context).isTrue();
      if (type_ == AND && !result) return false;
      else if (type_ == OR && result) return true;
  }

  return  type_ == AND;  // true for AND false for OR
}

}
