/***************************************************************************
                          groupcomponent.h  -  description
                             -------------------
    begin                : Fri May 21 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GROUPCOMPONENT_H
#define GROUPCOMPONENT_H

#include "parentcomponent.h"
#include "xpathstring.h"
#include "number.h"
#include "boolean.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class GroupComponent : public ParentComponent  {
  public:
    enum GroupType { AND, OR };

  	GroupComponent(GroupType type);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    GroupComponent& copy() { return *(new GroupComponent(*this)); }

  private:
    GroupType type_;
  };
}


#endif
