/***************************************************************************
                          htmldeclaration.h  -  description
                             -------------------
    begin                : Mon Aug 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HTMLDECLARATION_H
#define HTMLDECLARATION_H

#include "processinginstruction.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class HTMLDeclaration : public ProcessingInstruction  {
  public:
  	HTMLDeclaration(const DOMString& version, const DOMString& encoding,
          const DOMString& standalone);
    HTMLDeclaration(const HTMLDeclaration& refNode);
    HTMLDeclaration& operator=(const HTMLDeclaration& refNode);

    static HTMLDeclaration failDeclaration;

    DOMString getData() const;
    DOMString getVersion() const;
    DOMString getEncoding() const;
    DOMString getStandAlone() const;
    DOMString getDisplayString() const;
    Node& cloneNode(bool deep = false) const;

  protected:
    HTMLDeclaration& copy() { return *(new HTMLDeclaration(*this)); }

  };
}

#endif
