/***************************************************************************
                          idchecker.h  -  description
                             -------------------
    begin                : Sat Aug 6 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IDCHECKER_H
#define IDCHECKER_H

#include "nodesetprocessor.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class IDChecker : public NodeSetProcessor  {
  public:
  	IDChecker(const Expr& expr);

    double getPriority() { return 10; }
    Boolean getBoolean(Context& context) {
      return getNodeSet(context).getBoolean(context); }
    XPathString getString(Context& context) {
      return getNodeSet(context).getString(context); }
    Number getNumber(Context& context) {
      return getNodeSet(context).getNumber(context); }
    NodeSet getNodeSet(Context& context, bool exact = true);
    Expr eval(Context& context) { return getNodeSet(context); }

    NodeSet processNodeSet(NodeSet& nodeSet, Context& context, bool exact = true);

    IDChecker& copy() { return *(new IDChecker(*this)); }

  private:
    Expr expr_;

    NodeSet processNode(Node& node, XPathString& refString, bool exact);
  };
}

#endif
