/***************************************************************************
                          idcollector.cpp  -  description
                             -------------------
    begin                : Sat Jun 5 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "idcollector.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "nodeset.h"
#include "xpathstring.h"
#include "document.h"
#include "element.h"
#include "nodeset.h"


namespace limpid {

IDCollector::IDCollector(const Expr& expr): expr_(expr) {}

NodeSet IDCollector::getNodeSet(Context& context, bool exact) {
  return process(context.getNode(), context, exact);
}

NodeSet IDCollector::processNodeSet(NodeSet& nodeSet, Context& context, bool) {
  // exact flag is not used here
  NodeSet resultSet;
  size_t length = nodeSet.getLength();
  if (!length) return resultSet; // nothing to return

  Document& document = context.getNode().getOwnerDocument();
  DOMString idString = expr_.getString(context);

  for (size_t index = 0; index < length; ++index) {
    Node& node = nodeSet.item(index);
    context.setNode(node);
    context.setPosition(index);

    Element& hitNode = document.getElementById(idString, node);
    if (hitNode.isValid()) resultSet.addNode(hitNode);
  }

  return resultSet;
}

}

