/***************************************************************************
                          idgenerator.cpp  -  description
                             -------------------
    begin                : Mon May 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "idgenerator.h"
#include "converter.h"
#include "context.h"
#include "document.h"
#include "element.h"

namespace limpid {

IDGenerator::IDGenerator() {}

XPathString IDGenerator::getString(Context& context) {
  DOMString idString = "id";
  Node& node = context.getNode();
  if (node.getNodeType() != Node::DOCUMENT_NODE)
    idString += Converter::toString(context.getNode().getPosition());
  else {
    DOMString pathString =
      static_cast<Document &>(node).getDocumentElement().getAttribute("path-string");
    idString += pathString;
  }
  return idString;
}

}
