/***************************************************************************
                          iftemplate.cpp  -  description
                             -------------------
    begin                : Wed Nov 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "iftemplate.h"
#include "xpathfactory.h"
#include "domwriter.h"
#include "writer.h"
#include "expr.h"

namespace limpid {

IfTemplate::IfTemplate(DOMString& matchString, bool logic):
      Template(matchString),
      expr_(XPathFactory::getExpr(matchString)), logic_(logic) {}

bool IfTemplate::process(XSLContext& parentContext) {
  parentContext.updateCurrentNode();
  if (testTemplate(parentContext, true)) {
    templates_.process(parentContext);
    if (!logic_) return logic_;
  }
  return true;
}

bool IfTemplate::processNode(XSLContext& parentContext,Node& node) {
  parentContext.updateCurrentNode();
  if (testTemplate(parentContext, true) == logic_) {
    templates_.processNode(parentContext, node);
    if (!logic_) return logic_;
  }
  return true;
}

bool IfTemplate::testTemplate(XSLContext& parentContext, bool exact) {
  if (expr_.isNodeSet())
    return expr_.getNodeSet(parentContext, exact).getLength();
  else
    return expr_.getBoolean(parentContext).isTrue();
}

}
