/***************************************************************************
                          iftemplate.h  -  description
                             -------------------
    begin                : Wed Nov 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IFTEMPLATE_H
#define IFTEMPLATE_H

#include "template.h"
#include "compoundtemplate.h"
#include "nodeset.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class IfTemplate : public Template  {
  public:
  	IfTemplate(DOMString& matchString, bool logic = true);

    void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }
    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);

    IfTemplate& copy() { return *(new IfTemplate(*this)); }

  protected:
    Expr expr_;
    bool logic_;
    CompoundTemplate templates_;

    bool testTemplate(XSLContext& parentContext, bool exact);
  };
}

#endif
