/***************************************************************************
 *   Copyright (C) 2007 by root     *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDINSPECTOR_H
#define LIMPIDINSPECTOR_H

#include "documentprocessor.h"
#include "domutils.h"
#include "documentsummary.h"

namespace limpid {
  class Document;

/**
	@author root <john_redmond@optusnet.com.au>
*/
class Inspector : public DocumentProcessor, public DOMUtils {
public:
    Inspector() {}
    Document& processDocument(Document&);
    Inspector& copy() { return *(new Inspector(*this)); }
private:
    DocumentSummary documentSummary_;

    void setTypes();
    void setRoot();
    void setTitle();
    void setStyles(Node& parentNode);
    void setStyle(const DOMString& key, const DOMString& preString, Node& parentNode);
    void setStyle(const DOMString& key, const DOMString& preString, const DOMString& postString, Node& parentNode);
    void setSections();
    void setSection(const DOMString& pathString, const DOMString& sectionType);
    void setMixed();
    void setTailHeadings();
    void setHeadings();
    void setSubheadings();
    void setHeading(NodeSummary& nodeSummary, Char suffix);
    void setSubheading(NodeSummary& nodeSummary, Char suffix);
    void setTailHeading(NodeSummary& nodeSummary, Char suffix);
    void setGroups();
    void setFeatures();
    void setFeature(NodeSummary& nodeSummary, Char tag);
    void setUntyped();

    void appendFormat(Node& parentNode);
    void appendTOCHeaders(Node& parentNode);
    void appendBodyHeaders(Node& parentNode);
    void appendHeader(const DOMString& name, const DOMString& style, Node& parentNode);

    void appendPackages(Node& parentNode);
    void appendPackage(const DOMString& name, const DOMString& value, Node& parentNode);

};

}

#endif
