/***************************************************************************
                          joiner.h  -  description
                             -------------------
    begin                : Mon May 8 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef JOINER_H
#define JOINER_H

#include "documentprocessor.h"
#include "writer.h"
#include "domwriter.h"

/**
  *@author John Redmond
  */

namespace limpid {  
  class Joiner : public DocumentProcessor  {
  public:
    Joiner(const DOMString& destPath);
    Joiner(const DOMString& destPath, const DOMString& rootName, const DOMString& titleString);
    Document& processDocument(Document& document);
    void start();
    void finish();
    Joiner& copy() { return *(new Joiner(*this)); }

  private:
    DOMString destPath_, rootName_, titleName_, titleString_;
    Pointer<Writer> writer_;
    Pointer<DOMWriter> domWriter_;
    Document document_;

    void setTitleStrings(const DOMString& titleString);
  };
}

#endif
