/***************************************************************************
                          keymanager.h  -  description
                             -------------------
    begin                : Wed Aug 3 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KEYMANAGER_H
#define KEYMANAGER_H


/**
  *@author John Redmond
  */

#include "domstring.h"
#include "configurationset.h"
#include <map>

namespace limpid {
  class ConfigurationSet;

  typedef std::map<DOMString, KeySpecs> KeyMap;

  class KeyManager {
  public:
  	KeyManager();
    DOMString getExprString(const ConfigurationSet& configurationSet,
      const DOMString& sourceString);

  private:
    size_t getKeyEnd(const DOMString& sourceString,
      const DOMString& name, size_t startIndex);
    DOMString getKeyedExprString(const ConfigurationSet& configurationSet,
      const DOMString& keyString);
  };
}

#endif
