/***************************************************************************
                          lexxia.cpp  -  description
                             -------------------
    begin                : Wed Sep  1 13:26:35 EST 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "writer.h"
#include "lexxiaapp.h"
#include "reader.h"
#include "ccparser.h"
#include "node.h"
#include "domwriter.h"

namespace limpid {

void printLine(const char* line) {
  wrt::Errors << line << wrt::endl;
}

void printInfo() {
  printLine("Error: lexxia requires at least 2 args to be useful.");
//  printLine("The first param specifies the source file (XML, HTML, XHTML, SXF, CSV, XSF or DTD)");
//  printLine("The subsequent parameters all require a dashed prefix:");
//  printLine("-O+fname: print XML to file fname");
//  printLine("-O+html: print HTML to standard output");
}

int launchApp(int argc, char *argv[]) {
  if (LexxiaApp().exec(argc, argv) != 0) { // problems
    wrt::Errors << "Error: args are not correct" << wrt::endl;
    return 1;
  }

  return 0; // success
}

}

int doMain(int argc, char *argv[]) {
  try {
    limpid::launchApp(argc, argv);
    return EXIT_SUCCESS;
  }
  catch (limpid::DOMException& ex) {
    limpid::wrt::Errors << "DOMException" << ex.getMessage() << limpid::wrt::endl;
    return 1;
  }
  catch (std::exception& ex) {
    limpid::wrt::Errors << "std Exception: " << ex.what() << limpid::wrt::endl;
    return 1;
  }
  catch (...) {
    limpid::wrt::Errors << "Unknown exception" << limpid::wrt::endl;
    return 1;
  }
}

  int main(int argc, char *argv[]) { return doMain(argc, argv); }

