/***************************************************************************
                          liststream.h  -  description
                             -------------------
    begin                : Tue Oct 7 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LISTSTREAM_H
#define LISTSTREAM_H

#include "nodesource.h"
#include "nodelist.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class ListStream : public NodeSource  {
  public:
    ListStream();
    ListStream(NodeList& nodeList);
    ListStream(Node& parent);

    Node& nextNode();
    void setRoot(const Node&);
    void setForward(bool direction);
    ListStream & copy() { return *(new ListStream(*this)); }

  private:
    NodeList* nodeList_;
    int index_, length_;
    bool direction_;
  };
}
#endif
