/***************************************************************************
                          matchedtemplate.cpp  -  description
                             -------------------
    begin                : Mon Sep 27 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "matchedtemplate.h"
#include "xpathfactory.h"

namespace limpid {

MatchedTemplate::MatchedTemplate(const DOMString& matchString, const DOMString& modeString):
  Template(matchString), reverseExpression_ (XPathFactory::getReverseExpr(matchString, false)), mode_(modeString) {
  if (matchString.size())
    priority_ = XPathFactory::getExpr(matchString).getPriority();
}

bool MatchedTemplate::matchNode(Node& node, bool exact) {
  if (matchValue_ == "/" && node.getNodeType() == Node::DOCUMENT_NODE) return true;
  context_.setNode(node);
  context_.updateCurrentNode();
  context_.clearVariables();

  return reverseExpression_.getNodeSet(context_, exact).getLength();
}

};

