/***************************************************************************
                          matchedtemplate.h  -  description
                             -------------------
    begin                : Mon Sep 27 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MATCHEDTEMPLATE_H
#define MATCHEDTEMPLATE_H

#include "template.h"
#include "contexthandler.h"
#include "compoundtemplate.h"
#include "expr.h"
#include "writer.h"
#include "expressionmap.h"
#include "parameterhandler.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;
  class ExpressionMap;

  class MatchedTemplate : public Template  {
  public:
  	MatchedTemplate(const DOMString& matchString, const DOMString& modeString = "");

    bool process(XSLContext& parentContext) {
      return templates_.process(parentContext); }
    bool processNode(XSLContext& parentContext, Node& node) {
      return templates_.processNode(parentContext, node); }

    void setParameter(const DOMString& key, const Expr& expr) {
      defaultParameters_.setExpr(key, expr); }
    void passParameters(const ExpressionMap& parameterMap, XSLContext& context) {
      ParameterHandler(context).resolveParameters(parameterMap, defaultParameters_); }

    void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }
    bool matchNode(Node& node, bool exact = true);

    size_t getLength() { return templates_.getLength(); }
    DOMString getMode() { return mode_; }

    MatchedTemplate& copy() { return *(new MatchedTemplate(*this)); }

  private:
    Expr reverseExpression_;
    DOMString mode_;
    ExpressionMap defaultParameters_;
    CompoundTemplate templates_;
    XSLContext context_;
  };
}

#endif
