/***************************************************************************
                          messagetemplate.h  -  description
                             -------------------
    begin                : Mon Jan 17 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MESSAGETEMPLATE_H
#define MESSAGETEMPLATE_H

#include "compoundtemplate.h"
#include "writer.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class MessageTemplate : public Template  {
  public:
  	MessageTemplate(bool terminate);

     bool process(XSLContext& parentContext);
     bool processNode(XSLContext& parentContext, Node&) { return process(parentContext); }
     void addTemplate(Template& childTemplate) { templates_.addTemplate(childTemplate); }
     MessageTemplate& copy()  { return *(new MessageTemplate(*this)); }

   private:
    Pointer<Writer> errorWriter_;
    CompoundTemplate templates_;
    bool terminate_;
  };
}

#endif
