/***************************************************************************
                          nametest.cpp  -  description
                             -------------------
    begin                : Wed Oct 22 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nametest.h"
#include "writer.h"

namespace limpid {

NameTest::NameTest(const DOMString& name): refName_(name), hasPrefix_(false) {
  size_t colonIndex = name.indexOf(":");
  if (colonIndex != name.npos) {
    refPrefix_ = name.substr(0, colonIndex);
    refName_ = name.substr(colonIndex + 1, name.size() - colonIndex - 1);
    hasPrefix_ = true;
  }
}

bool NameTest::test(Node& node) {
  int nodeType = node.getNodeType();
  if (nodeType != Node::ELEMENT_NODE && nodeType != Node::ATTRIBUTE_NODE)
    return node.getNodeName() == refName_;

  if (!hasPrefix_)
    return refName_ == "*" || node.getNodeName() == refName_;

  if (node.getPrefix() != refPrefix_) return false;
  return refName_ == "*" || node.getLocalName() == refName_;
}

}
