/***************************************************************************
                          nodecontent.h  -  description
                             -------------------
    begin                : Tue May 27 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODECONTENT_H
#define NODECONTENT_H

#include <iostream>

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;
  class ParentContent;
  class DocumentContent;
  class NodeList;
  class NamedNodeMap;
  class Document;

  class NodeContent {
    friend class NodeList;
    friend class NamedNodeMap;

  public:
    NodeContent(short type);
    virtual ~NodeContent();
    size_t refCount_;
    int position_;
    short nodeType_;
    bool readOnly_, specified_, isParent_;
    DocumentContent *documentContent_;
    ParentContent *parentContent_;
    Node *previousSibling_, *nextSibling_;

    virtual size_t getSize() { return sizeof(*this); }
  };
}
#endif
