/***************************************************************************
                          nodereporter.cpp  -  description
                             -------------------
    begin                : Fri Jul 8 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nodereporter.h"
#include "expr.h"

namespace limpid {

NodeReporter::NodeReporter(const DOMString& typeString, Expr& expr): expr_(expr) {
  if (typeString == "name") type_ = NAME;
  else if (typeString == "local-name") type_ = LOCAL_NAME;
  else type_ = NAMESPACE_URI;
}

XPathString NodeReporter::getString(Context& context) {
  NodeSet resultSet = expr_.getNodeSet(context);
  if (!resultSet.getLength()) return "";

  Node& firstNode = resultSet.getItem(0);

  if (type_ == NAME) return firstNode.getNodeName();

  if (type_ == LOCAL_NAME) {
    XPathString name = firstNode.getLocalName();
    if (!name.empty()) return name;
    else return firstNode.getNodeName();  // not a qualified name
  }

  return firstNode.getNamespaceURI();
}

}

