/***************************************************************************
                          nodereporter.h  -  description
                             -------------------
    begin                : Fri Jul 8 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODEREPORTER_H
#define NODEREPORTER_H

#include "xpathexpression.h"
#include "domstring.h"
#include "expr.h"
#include "xpathfactory.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Expr;
  class NodeReporter: public XPathExpression  {
    enum ReporterType { NAME, LOCAL_NAME, NAMESPACE_URI };
    public:
    	NodeReporter(const DOMString& typeString, Expr& expr);

    Boolean getBoolean(Context& context) {
      return getString(context).getBoolean(context); }
    XPathString getString(Context& context);
    Number getNumber(Context& context) {
      return getString(context).getNumber(context); }

    bool isValid() { return true; }
    Expr eval(Context& context) { return getString(context); }

    NodeReporter& copy() { return *(new NodeReporter(*this)); }
    private:
      ReporterType type_;
      Expr expr_;
  };
}

#endif
