/***************************************************************************
                          nodesetcounter.cpp  -  description
                             -------------------
    begin                : Fri Jun 18 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nodesetcounter.h"
#include "nodeset.h"

namespace limpid {

NodeSetCounter::NodeSetCounter(): ParentComponent() {
}

Boolean NodeSetCounter::getBoolean(Context& context) {
  return getNumber(context).getBoolean(context);
}

XPathString NodeSetCounter::getString(Context& context) {
  return getNumber(context).getString(context);
}

Number NodeSetCounter::getNumber(Context& context) {
  if (!getLength()) return 0;
  else return int(components->at(0)->getNodeSet(context).getLength());
}

}
