/***************************************************************************
                          nodesetprocessor.h  -  description
                             -------------------
    begin                : Sun May 16 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODESETPROCESSOR_H
#define NODESETPROCESSOR_H

#include "nodeset.h"
#include "context.h"
#include "xpathexpression.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class NodeSetProcessor: public XPathExpression {
  public:
  	NodeSetProcessor(): priority_(0) {}
    virtual ~NodeSetProcessor() {}

    NodeSet process(Node& node, Context& context, bool exact) {
      NodeSet nodeSet; nodeSet.addNode(node); return processNodeSet(nodeSet, context, exact); }
    bool isNodeSet() { return true; }
    bool isValid() { return true; }
    double getPriority() { return priority_; }
    void setPriority(double priority) { priority_ = priority; }
    virtual NodeSet processNodeSet(NodeSet& nodeSet,
      Context& context, bool extract = true) { return nodeSet; }
    NodeSetProcessor& copy() { return *(new NodeSetProcessor(*this)); }
    
  protected:
    double priority_;
  };
}
#endif
