/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDNODESTACK_H
#define LIMPIDNODESTACK_H

#include <deque>
#include "document.h"
#include "endnode.h"
#include "writer.h"

namespace limpid {

/**
	@author John Redmond <john_redmond@optusnet.com.au>
*/
class NodeStack{
public:
    NodeStack() {}
    void push(Node& node) { stack_.push_back(&node); currentNode_ = &node; }
    void update(EndNode& endNode) { endNode.update(*currentNode_); pop(); }
    void empty() {
      while (stack_.size()) {
        delete(stack_.back());
        pop();
      }
    }

private:
    typedef std::deque<Node*> Stack;

    Stack stack_;
    Document* document_;
    Node *currentNode_;  // not managed

    bool pop() {
      if (stack_.size() > 1) {
//        delete (stack_.back());
//        currentNode_ = stack_.back();
        stack_.pop_back();
        return true;
      }
      else return false;
    }
};

}

#endif
