/***************************************************************************
                          nodestream.h  -  description
                             -------------------
    begin                : Sun Oct 5 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NODESTREAM_H
#define NODESTREAM_H

#include <list>
#include "nodesource.h"
#include "endnode.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class NodeStream : public NodeSource  {
  public:
    NodeStream(bool inclEnds = false, bool inclRoot = true);
  	NodeStream(const Node& root, bool inclEnds = false, bool inclRoot = true);

    Node& nextNode();
    void setIncludeChildren(bool flag) { includeChildren = flag; }
    void setRoot(const Node& root);

    NodeStream& copy() { return *(new NodeStream(*this)); }

  private:
    Node *root, *currentNode, *refNode;
    EndNode endNode;
    bool includeEnds, includeRoot, finished, ascending, includeChildren;
    Node& getNext();
    Node& getNextAbove();

    void reset();
  };
}
#endif
