/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   root john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDNODESUMMARY_H
#define LIMPIDNODESUMMARY_H

#include "domstring.h"
#include <set>
#include <map>
#include <vector>

namespace limpid {

/**
	@author root <john_redmond@optusnet.com.au>
*/

  typedef std::vector<DOMString> StringList;
  typedef std::set<DOMString> StringSet;
  typedef std::map<DOMString, int> IntegerMap;
  typedef std::map<DOMString, int> BooleanMap;


  struct NodeSummary {
    NodeSummary(): isSection(false), isLeaf(false), hasText(true),
      textBefore(false), textAfter(false),
      alwaysFirst(false), alwaysSecond(false), alwaysLast(false), everLast(false),
      alreadyUsed(false), hasTailHeading(false), totalCount(1), descendantMax(0),
      /*selfMax(1), selfMin(INT_MAX), siblingMax(0), siblingMin(INT_MAX), leafMax(0),
       leafMin(INT_MAX), descendantMax(0), descendantMin(INT_MAX),*/ depth(0) {}

    DOMString tag, nodeName, matchString, path, parentPath;
    DOMString type, alignment, style, cssStyle;
    bool isSection, isFeature, isLeaf, leafFollows, hasText, textBefore, textAfter,
        alwaysFirst, alwaysSecond, alwaysLast, everLast, alreadyUsed, hasTailHeading;
    int totalCount, selfMax, selfMin, descendantTotal, depth, siblingMin,
        leafMax, leafMin, descendantMax, descendantMin, position;
    StringList childNames, childPaths;
    StringSet childSet, siblingBefore, siblingAfter;
  };

}

#endif
