/***************************************************************************
                          nodetest.cpp  -  description
                             -------------------
    begin                : Thu Jan 20 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "nodetest.h"
#include "element.h"
#include "writer.h"

namespace limpid {

NodeTest::NodeTest(Node& refNode): refType_(refNode.getNodeType()) {
  refName_ = refNode.getNodeName();
  if (false && refType_ == Node::ELEMENT_NODE) {
    refNamespace_ = refNode.getNamespaceURI();
  }
}

bool NodeTest::test(Node& node) {
  if (node.getNodeType() != refType_) return false;
  if (node.getNodeName() != refName_) return false;
  return node.getNamespaceURI() == refNamespace_;
}

DOMString NodeTest::getNodeName(Element& element) {
  DOMString name = element.getLocalName();
  if (!name.empty()) return name;
  else return element.getNodeName();
}

}
