/***************************************************************************
                          notationcontent.cpp  -  description
                             -------------------
    begin                : Wed Sep 24 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "node.h"
#include "notationcontent.h"

namespace limpid {

NotationContent::NotationContent(const DOMString& name,
      const DOMString& pubId, const DOMString& sysId):
    NamedContent(Node::NOTATION_NODE), publicId_(0), systemId_(0) {
  try {
    nodeName_ = name.copyChars();
    publicId_ = pubId.copyChars();
    systemId_ = sysId.copyChars();
  }
  catch (std::bad_alloc) {
    delete [] publicId_;
    delete [] systemId_;
  }
}

NotationContent::~NotationContent() {
  delete [] publicId_;
  delete [] systemId_;
}

size_t NotationContent::getSize() {
  size_t size = sizeof(*this);

  if (prefix_) size += (DOMString::strLength(prefix_) + 1) * sizeof(Char);
  if (nodeName_) size += (DOMString::strLength(nodeName_) + 1) * sizeof(Char);
  if (publicId_) size += (DOMString::strLength(publicId_) + 1) * sizeof(Char);
  if (systemId_) size += (DOMString::strLength(systemId_) + 1) * sizeof(Char);

  return size;
}

}
