/***************************************************************************
                          number.cpp  -  description
                             -------------------
    begin                : Mon Feb 16 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "number.h"
#include "expr.h"

namespace limpid {

Number::Number(): XPathExpression(), value_(0) {}

Number::Number(double value): XPathExpression(), value_(value) {}

Number::Number(const DOMString& valString):
  value_(valString.empty() ? 0 :
    Converter::toDouble(const_cast<DOMString &>(valString).resolveEntities())) {}

XPathString Number::getString(Context&) { return Converter::toString(value_); }

Expr Number::eval(Context& context) {
  return getNumber(context);
}

}
