/***************************************************************************
                          numbercomparison.h  -  description
                             -------------------
    begin                : Mon May 17 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NUMBERCOMPARISON_H
#define NUMBERCOMPARISON_H

#include "parentcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class NumberComparison : public ParentComponent  {
  public:
    enum Type { EQ, LT, GT };

  	NumberComparison(Type type = EQ, bool logic = true);
    NumberComparison(const DOMString& typeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context);
    Expr eval(Context& context);

    NumberComparison& copy() { return *(new NumberComparison(*this)); }

    protected:
      Type type_;
      bool logic_;

      bool comparePair(XPathExpression& first, XPathExpression& second, Context& context);
      bool compareFirstNodeSet(XPathExpression& first, XPathExpression& second,
        Context& context);
      bool compareSecondNodeSet(XPathExpression& first, XPathExpression& second,
        Context& context);
      bool compareNumbers(double firstValue, double secondValue);
      void setMode(const DOMString& modeString);
  };
}

#endif
