/***************************************************************************
                          numbergenerator.h  -  description
                             -------------------
    begin                : Sat May 29 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NUMBERGENERATOR_H
#define NUMBERGENERATOR_H

#include "parentcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class NumberGenerator : public ParentComponent  {
  public:
    enum ContextType { COUNT = 0, LAST, POSITION, STRING_LENGTH,
                        FLOOR, CEILING, ROUND, SUM, NUMBER };
  	NumberGenerator(ContextType);
    NumberGenerator(const DOMString& typeString);

    Boolean getBoolean(Context& context) {
      return getNumber(context).getBoolean(context); }
    XPathString getString(Context& context) {
      return getNumber(context).getString(context); }
    Number getNumber(Context& context);
    Expr eval(Context& context) { return getNumber(context); }

    NumberGenerator& copy() { return *(new NumberGenerator(*this)); }

  private:
    ContextType type_;

    void setType(DOMString typeString);
    Number getStringLength(Context& context);
    Number getChildNumber(Context& context);
    Number getApproximate(Context& context);
    Number getSum(Context& context);
  };
}

#endif
