/***************************************************************************
                          numberstyler.cpp  -  description
                             -------------------
    begin                : Fri May 6 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "numberstyler.h"
#include "context.h"
#include "decimalformat.h"
#include "decimalformatter.h"
#include "decimalformatmap.h"

namespace limpid {

NumberStyler::NumberStyler() {}

Boolean NumberStyler::getBoolean(Context& context) {
  return getItem(0).getBoolean(context);
}

XPathString NumberStyler::getString(Context& context) {
  size_t length = getLength();
  if (length < 2) return "missing parameters in number format";  // this is a failure

  double d = getItem(0).getNumber(context).getValue();
  DOMString formatString = getItem(1).getString(context);

  if (length == 2) return DecimalFormatter(formatString).format(d);
  else {
    DOMString formatName = getItem(2).getString(context);
    const DecimalFormat format =
      context.getDecimalFormatMap().getFormat(formatName);
    return DecimalFormatter(formatString).format(d);//, format);
  }
}

Number NumberStyler::getNumber(Context& context) {
  if (getLength() < 2) return 0;
  return getItem(0).getNumber(context);
}

}
