/***************************************************************************
                          optionexpr.cpp  -  description
                             -------------------
    begin                : Tue Nov 23 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "optionexpr.h"
#include "writer.h"
#include "xpathbuilder.h"
#include "xpathorganizer.h"
#include "xpathstring.h"
#include "boolean.h"
#include "number.h"
#include "nodeset.h"
#include "xpathfactory.h"

namespace limpid {

OptionExpr::OptionExpr(): PathExpr() {
}

NodeSet OptionExpr::processNodeSet(NodeSet& nodeSet, Context& context, bool exact) {
  NodeSet resultSet;

  ComponentList::iterator p = processors->begin();
  while (true) {
    if (p == processors->end()) break;
    NodeSetProcessor& processor = **p;
    NodeSet processorSet = processor.processNodeSet(nodeSet, context, exact);
    copyNodes(resultSet, processorSet);
    ++p;
  }

  sorter_.doSort(resultSet);

  return resultSet;
}

void OptionExpr::copyNodes(NodeSet& resultSet, NodeSet& partialSet) {
  for (size_t index = 0; index < partialSet.getLength(); ++index)
    resultSet.addNode(partialSet.getItem(index));
}

}
