/***************************************************************************
                          optionexpr.h  -  description
                             -------------------
    begin                : Tue Nov 23 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OPTIONEXPR_H
#define OPTIONEXPR_H

/**
  *@author John Redmond
*/

#include <vector>
#include "node.h"
#include "domstring.h"
#include "test.h"
#include "sorter.h"
#include "xpathparser.h"
#include "pathexpr.h"

namespace limpid {
  class OptionExpr: public PathExpr {
    public:
      OptionExpr();

      NodeSet processNodeSet(NodeSet& nodeSet, Context& context, bool exact = true);
      OptionExpr& copy() { return *(new OptionExpr(*this)); }

    private:
      Sorter sorter_;
      void copyNodes(NodeSet& resultSet, NodeSet& partialSet);
  };
}

#endif
