/***************************************************************************
                          outputformat.h  -  description
                             -------------------
    begin                : Tue Sep 6 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OUTPUTFORMAT_H
#define OUTPUTFORMAT_H

#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class OutputFormat {
    public:
  	OutputFormat(): isStarted(false), isFormatting(false), isHTML(false), elementAdded(false),
        newline("\n"), addIndent(" ") {}

    bool isStarted, isFormatting, isHTML, elementAdded;
    DOMString newline, indentation, addIndent, startString, finishString;

    void setFormat(const DOMString& nline, const DOMString& indent, const DOMString add) {
      newline = nline; indentation = indent; addIndent = add; isFormatting = add.size(); }
    void setStartAndFinish(const DOMString& start, const DOMString& finish) {
      startString = start; finishString = finish; }

    void nest() { indentation += addIndent; }
    void deNest() {
      int length = indentation.size(); int addIndentSize = addIndent.size();
      if (length >= addIndentSize)
        indentation = indentation.substring(0, length - addIndentSize);
    }
  };
}

#endif
