/***************************************************************************
                          outputmanager.h  -  description
                             -------------------
    begin                : Fri Apr 1 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OUTPUTMANAGER_H
#define OUTPUTMANAGER_H

#include "writer.h"
#include "documenttype.h"
#include "configurationset.h"
#include "xslcontext.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class DOMString;
  class XSLResources;
  class XSLContext;
  class DOMWriter;

  class OutputManager {
  public:
  	OutputManager();

    void setWriter(XSLContext& context,
      const DOMString& pathString, ConfigurationSet& configurationSet);
    void setWriter(XSLContext& context, ConfigurationSet& configurationSet);
    void setWriter(XSLContext& context,
      CharacterWriter& writer, ConfigurationSet& configurationSet);

    void initializeDocument(Document& document, ConfigurationSet& configurationSet);
    void setCDATASectionNames(XSLResources& templateMap, ConfigurationSet& configurationSet);

  private:
    void setupWriters(CharacterWriter& writer,
      XSLContext& context, ConfigurationSet& configurationSet);
    void initializeWriter(CharacterWriter& writer,
      ConfigurationSet& configurationSet);
    DocumentType getDoctype(const DOMString& type,
      const ConfigurationSet& configurationSet);
    void setDeclaration(CharacterWriter& writer, ConfigurationSet& configurationSet);
  };
}

#endif
