/***************************************************************************
                          outputstream.cpp  -  description
                             -------------------
    begin                : Fri Jun 25 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include "outputstream.h"
#include "writer.h"

using namespace std;

namespace limpid {

OutputStream::OutputStream(bool useConsole): url_(useConsole) {
  setOutput(url_);
}

OutputStream::OutputStream(const URL& url): url_(url) {
  setOutput(url_);
}

OutputStream::OutputStream(ofstream* rawInput): output_(rawInput),
    fileOutput_(rawInput) {}

void OutputStream::setOutput(URL& url) {
  try {
    output_ = &std::cout;

    output_ = &url.getOutput();
    if (!url.isDefault()) {
      fileOutput_= static_cast<std::ofstream *>(output_);  // it must be a file stream;
      fileOutput_->clear();
    }
  }
  catch (...) {
    std::cout << "OutputSteam exception caught: " << std::endl;

  }
}

void OutputStream::close() {
  if (fileOutput_) {
    fileOutput_->close();
  }
  else {
    output_->flush();
  }
}

}
