             /***************************************************************************
                          outputstream.h  -  description
                             -------------------
    begin                : Fri Jun 25 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef OUTPUTSTREAM_H
#define OUTPUTSTREAM_H

#include <iostream>
#include <fstream>
#include "iobase.h"
#include "url.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

//using std::ostream;
//using std::ofstream;
//using namespace std;

namespace limpid {
  class OutputStream: public IOBase {
    friend class Writer;

    class DOMString;
  public:
    explicit OutputStream(bool useConsole = true);
    OutputStream(const URL& url);
    OutputStream(std::ofstream* rawInput);

    int putByte(char c) { output_->put(c);  return 1; }
    bool isValid() const { return *output_; }
    bool isDefault() const { return url_.isDefault(); }
    std::ostream& getOutput() { return *output_; }
    URL getURL() { return url_; }
    const char* getString();
    void flush() { output_->flush(); }
    void close();

  protected:
    std::ostream *output_;
    Pointer<std::ofstream> fileOutput_; // this is a sentinal for output_
    URL url_;

    void setOutput(URL& url);
    void setContent(DOMString& sourceString);
  };
}

#endif
