/***************************************************************************
                          parameterhandler.cpp  -  description
                             -------------------
    begin                : Thu Jul 21 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "parameterhandler.h"
#include "contexthandler.h"
#include "xpathfactory.h"
#include "node.h"
#include "xslcontext.h"

namespace limpid {

ParameterHandler::ParameterHandler(XSLContext& context): context_(&context) {}

void ParameterHandler::resolveParameters(const ExpressionMap& passedParameters,
    const ExpressionMap& defaultParameters)  {

  size_t length = defaultParameters.getLength();
  if (!length) return;

  for (size_t index = 0; index < length; ++index) {
    DOMString key = defaultParameters.getKey(index);

    Expr passedExpression = passedParameters.getExpr(key);
    if (passedExpression.isValid())
      context_->setVariable(key, passedExpression.eval(*context_));
    else
      context_->setVariable(key, defaultParameters.getExpr(index).eval(*context_));
  }
}

}
