/***************************************************************************
                          parentcomponent.h  -  description
                             -------------------
    begin                : Mon May 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PARENTCOMPONENT_H
#define PARENTCOMPONENT_H

#include <vector>
#include "expr.h"
#include "pointer.h"

/**
ParentComponent is an XPathExpression that simplifies construction of complex
expressions. 

  @author root <john_redmond@optusnet.com.au>
*/

namespace limpid {
  class ParentComponent : public XPathExpression  {
    friend class XPathBuilder;  // to provide access to constructor

  public:
    void appendChild(XPathExpression& child);
    size_t getLength() { return components->size(); }
    bool hasItem(size_t index) { return index < components->size(); }
    XPathExpression& getItem(size_t index) { return *(components->at(index)); }

    bool isValid() { return true; }
    ParentComponent& copy() { return *(new ParentComponent(*this)); }

  protected:
    ParentComponent();  // intended only for inheritance

    typedef Pointer<XPathExpression> XPEPointer;
    typedef std::vector<XPEPointer > ComponentList;

    Pointer<ComponentList> components;
  };
}


#endif
