/***************************************************************************
                          parentcontent.cpp  -  description
                             -------------------
    begin                : Wed Sep 10 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "parentcontent.h"
#include "parentnode.h"
#include "nodelist.h"

namespace limpid {

ParentContent::ParentContent(short type, const DOMString& name, ParentNode& parent):
  NamedContent(type, name), ownerNode_(&parent), childNodes_(0) {
}

ParentContent::~ParentContent() {
  delete childNodes_;
}

size_t ParentContent::getSize() {
  size_t size = sizeof(*this);

  if (prefix_) size += (DOMString::strLength(prefix_) + 1) * sizeof(Char);
  size += (DOMString::strLength(nodeName_) + 1) * sizeof(Char);
  if (childNodes_) size += childNodes_->getSize();

  return size;
}

}
