/***************************************************************************
                          parentnode.h  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/**
  *@author John Redmond
  */


#ifndef PARENTNODE_H
#define PARENTNODE_H

#include <iostream>
#include "node.h"
#include "nodelist.h"

namespace limpid {
  class Element;

  class ParentNode : public Node  {
  public:
    friend class NodeList;

  //DOM:
    DOMString getNodeName() const;
    DOMString getLocalName() const;
    DOMString getPrefix() const;
    void setPrefix(const DOMString& prefix);

    NodeList& getChildNodes() const;
    Node& getFirstChild() const;
    Node& getLastChild() const;
    bool addChildNodes();
    bool hasChildNodes() const;
    Node& appendChild(Node& childNode);
    Node& removeChild(Node& childNode);
    Node& replaceChild(Node& newChild, Node& oldChild);
    Node& insertBefore(Node& newChild, Node& refchild);
    void normalize();

  //non-DOM:
    void setDocumentContent(DocumentContent& documentContent);
    bool hasNonTextChildren() const;

  protected:
    ParentNode();
//    ~ParentNode();

    Node& appendSingleNode(Node& childNode);
    Node& insertSingleNode(Node& newChild, Node& refChild);

    void removeParentNode() { nodeContent_->parentContent_ = 0; }
    void detachNode(Node& node);
    virtual void clearLinks();
    virtual void connect();
  };
}
#endif
