/***************************************************************************
                          parser.h  -  description
                             -------------------
    begin                : Fri Apr 21 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PARSER_H
#define PARSER_H

#include "copied.h"
#include "node.h"

namespace limpid {
  class Parser: public Copied {
  public:
    Parser(): trimText_(false), normalizeText_(false) {}

    virtual Node& nextNode() { return Node::failNode; }
    virtual void setRoot(const Node&) {};
    void setTrimText(bool trim) { trimText_ = trim; }
    void setNormalizeText(bool trim) { normalizeText_ = trim; }
    virtual void setProcessingXSLT(bool) {}
    Parser& copy() { return *(new Parser(*this)); }

  protected:
    bool trimText_, normalizeText_;

    virtual bool isEmptyElement(Node&) { return true; }
    virtual void setNode(Node*) {}

    #define START 0
    #define STARTED 1
    #define DEFAULTSTART 2
    #define ERROR 3
    #define ANY 4
    #define FINISH 5
    #define DONE 6

    #define DEFAULTEND 11

    #define COMMENTSTART 12
    #define COMMENTEND 13

    #define STYLESTART 14
    #define STYLEEND 15

    #define ATSTART 16
    #define ATEND 17
    #define ATCONTENT 18

    #define BLOCKSTART 19
    #define BLOCKREADY 20
    #define HEADINGSTART 21
    #define HEADINGCONTENT 22

    #define TAGSTART 23
    #define ATTRIBUTESTART 24
    #define TEXTSTART 25
    #define PISTART 26
    #define XMLDECLARATIONSTART 27
    #define DOCUMENTTYPESTART 28
    #define CDATASTART 29

    #define CONTENTSTART 30
    #define CONTENT 31
    #define CONTENTEND 32

    #define TAGEND 33
    #define EMPTY 34
    #define DENEST 35
    #define PARTIALDENEST 36
  };
}

#endif
