/***************************************************************************
                          pathexpr.cpp  -  description
                             -------------------
    begin                : Mon Nov 22 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pathexpr.h"
#include "xpathstring.h"
#include "boolean.h"
#include "number.h"
#include "nodeset.h"
#include "domwriter.h"

namespace limpid {

PathExpr::PathExpr(): NodeSetProcessor(), processors(new ComponentList) {
}

NodeSet PathExpr::getNodeSet(Context& context, bool exact) {
  return process(context.getNode(), context, exact);
}

void PathExpr::addProcessor(NodeSetProcessor& processor) {
  processors->push_back(&processor.copy());
}

NodeSet PathExpr::processNodeSet(NodeSet& nodeSet, Context& context, bool exact) {
  NodeSet resultSet = nodeSet;

  ComponentList::iterator p = processors->begin();
  while (true) {
    if (p == processors->end()) break;

    NodeSetProcessor& processor = **p;
    resultSet = processor.processNodeSet(resultSet, context, exact);
    if (!resultSet.getLength()) break;
    if (!exact) break;
    ++p;
  }

  return resultSet;
}

}
