/***************************************************************************
                          pathexpr.h  -  description
                             -------------------
    begin                : Mon Nov 22 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PATHEXPR_H
#define PATHEXPR_H

/**
  *@author John Redmond
*/

#include <vector>
#include "nodesetprocessor.h"
#include "pointer.h"

namespace limpid {
  class PathExpr: public NodeSetProcessor {
    public:
      PathExpr();

      Boolean getBoolean(Context& context) {
        return getNodeSet(context).getBoolean(context); }
      XPathString getString(Context& context) {
        return getNodeSet(context).getString(context); }
      Number getNumber(Context& context) {
        return getNodeSet(context).getNumber(context); }
      NodeSet getNodeSet(Context& context, bool exact = true);
      Expr eval(Context& context) { return getNodeSet(context); }

      NodeSet processNodeSet(NodeSet& nodeSet, Context& context, bool exact = true);
      size_t getLength() { return processors->size(); }
      bool isNodeSet() { return true; }
      void addProcessor(NodeSetProcessor& processor);
      PathExpr& copy() { return *(new PathExpr(*this)); }

    protected:
      typedef Pointer<NodeSetProcessor> NSPPointer;
      typedef std::vector<NSPPointer > ComponentList;

      Pointer<ComponentList> processors;
  };
}

#endif
