/***************************************************************************
 *   Copyright (C) 2007 by John Redmond   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDPATHREGISTRY_H
#define LIMPIDPATHREGISTRY_H

#include "stringutils.h"
#include "node.h"
#include "selectionmanager.h"

namespace limpid {

/**
  @author John Redmond <john_redmond@optusnet.com.au>
*/
class PathRegistry: public StringUtils, Converter {
public:
    PathRegistry();
    void addPath(const DOMString& pathString);
    DOMString addPath(Element& element, const DOMString& priorityString, bool isXPathString);
    DOMString getPath(Node& node);
    DOMString getPathStyle(DOMString& pathString);
    DOMString correctPath(DOMString& valueString);
    const DOMString& getUncorrectedPath(const DOMString& correctedPath) { return pathMap_[correctedPath]; }

private:
    typedef std::map<DOMString, DOMString> StringMap;

    SelectionManager selectionManager_;
    StringMap pathMap_;
    char cssRefChar_, xpathRefChar_;

    void setPaths(Element& element, bool isXPathString);
};

}

#endif
