/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDPOINTTRACER_H
#define LIMPIDPOINTTRACER_H

#include "matchpoint.h"
#include "element.h"
#include "nodelist.h"
#include "writer.h"
#include "pointer.h"

namespace limpid {

/**
	@author John Redmond <john_redmond@optusnet.com.au>
*/
class PointTracer{
public:
  PointTracer();
  void traverse(MatchPoint& matchPoint);
//  int traverse(MatchPoint& matchPoint, NodeList& nodeList, int index = 0);
  bool trace(Node& element, MatchPoint& matchPoint, Writer& writer);

private:
    Pointer<Writer> writer;

  void addPoint(MatchList& matchList, MatchPoint& matchPoint);
  MatchList searchNext(Node& nextNode, MatchList& stateList);
  void getOptions(Node& node, MatchPoint& startPoint, MatchList& resultList);
};

}

#endif
