/***************************************************************************
                          positionsorterpolicy.h  -  description
                             -------------------
    begin                : Sat Jan 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef POSITIONSORTERPOLICY_H
#define POSITIONSORTERPOLICY_H

#include <vector>
#include <algorithm>
#include "sorterpolicy.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class PositionSorterPolicy : public SorterPolicy  {
  public:
  	PositionSorterPolicy() {}

    void process(std::vector<Node *>& data) { doSort(data); }
    PositionSorterPolicy& copy() { return *(new PositionSorterPolicy(*this)); }

  private:
    void doSort(std::vector<Node *>& data) {
      std::sort(data.begin(), data.end(), CompNodes());
    }

    class CompNodes {
    public:
    	CompNodes() {}

      bool operator()(Node* lhs, Node* rhs) const {
        return lhs->getPosition() < rhs->getPosition();
      }
    };
  };
}

#endif
