/***************************************************************************
                          predicate.cpp  -  description
                             -------------------
    begin                : Mon May 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "predicate.h"
#include "context.h"
#include "boolean.h"
#include "writer.h"

namespace limpid {

Predicate::Predicate(Expr& expr): expr_(expr) {}

NodeSet Predicate::processNodeSet(NodeSet& nodeSet, Context& context, bool) {
  // exact flag is not used here
  NodeSet resultSet;
  size_t length = nodeSet.getLength();
  context.setCount(length);

  for (size_t index = 0; index < length; ++index) {
    Node& node = nodeSet.getItem(index);
    context.setPosition(index + 1); // 1-based
    context.setNode(node);

    if (expr_.getBoolean(context).isTrue())
      resultSet.addNode(node);
  }

  return resultSet;
}

Expr Predicate::eval(Context& context) {
  NodeSet resultSet = NodeSetProcessor::process(context.getNode(), context, true);
  return Boolean(int(resultSet.getLength()));
}

}
