/***************************************************************************
                          processbox.h  -  description
                             -------------------
    begin                : Tue May 6 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROCESSBOX_H
#define PROCESSBOX_H

#include <vector>
#include <deque>
#include "domstring.h"
#include "node.h"
#include "processor.h"
#include "url.h"
#include "parser.h"
#include "xmlparser.h"
#include "iobase.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class ProcessBox : public Processor  {
  public:
    ProcessBox();
    ProcessBox(CharacterReader& reader);
    ProcessBox(const URL& url);
    ProcessBox(Parser &src);

    void setSource(Parser& parser);
    void process();
    void test();
    Node& process(Node& node);
    void start();
    void finish();
    void addProcessor(Processor& processor) { processors_->push_back(&processor.copy()); }
    void setProcessingXSLT(bool flag) { if (parser_) parser_->setProcessingXSLT(flag); }
    ProcessBox& copy() { return *(new ProcessBox(*this)); }

  private:
    typedef std::vector<Pointer<Processor> > ProcessorList;

    Pointer<Parser> parser_;
    Pointer<ProcessorList> processors_;

  };
}
#endif
