/***************************************************************************
                          processinginstruction.h  -  description
                             -------------------
    begin                : Tue Mar 18 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROCESSINGINSTRUCTION_H
#define PROCESSINGINSTRUCTION_H

#include "node.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class ProcessingInstruction : public Node  {
  public:
    //DOM:
    ProcessingInstruction();
  	ProcessingInstruction(const DOMString& target, const DOMString& data);
    ProcessingInstruction(const ProcessingInstruction& refNode);
    ProcessingInstruction& operator=(const ProcessingInstruction& refNode);

    DOMString getData() const;
    DOMString getNodeValue() const { return getData(); }
    DOMString getTarget() const;
    void setData(const DOMString& data);
    DOMString getNodeName() const;

    //non-DOM:
    DOMString getRawValue() const { return getData(); }
    void setNodeValue(DOMString& data) { setData(data); }
    DOMString getDisplayString() const;
    Node& cloneNode(bool deep = false) const;

  protected:
    ProcessingInstruction& copy() { return *(new ProcessingInstruction(*this)); }
  };
}
#endif
