/***************************************************************************
                          processinginstructioncontent.cpp  -  description
                             -------------------
    begin                : Fri Sep 12 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "processinginstructioncontent.h"

namespace limpid {

ProcessingInstructionContent::ProcessingInstructionContent(const DOMString& target,
       const DOMString& data):
  NodeContent(Node::PROCESSING_INSTRUCTION_NODE), target_(0), data_(0) {
  try {
    target_ = target.copyChars();
    data_ = data.copyChars();
  }
  catch (std::bad_alloc) {
    delete [] target_;
    delete [] data_;
    throw;
  }
}

ProcessingInstructionContent::~ProcessingInstructionContent(){
}

size_t ProcessingInstructionContent::getSize() {
  size_t size = sizeof(*this);

  if (target_) size += (DOMString::strLength(target_) + 1) * sizeof(Char);
  if (data_) size += (DOMString::strLength(data_) + 1) * sizeof(Char);

  return size;
}

}
