/***************************************************************************
                          putter.h  -  description
                             -------------------
    begin                : Tue Apr 11 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PUTTER_H
#define PUTTER_H

#include "documentprocessor.h"
#include "dumper.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Putter : public DocumentProcessor  {
  public:
    Putter(Dumper& dumper);
    Putter(const DOMString& destString, bool toConsole = false);

    Document& processDocument(Document& inputDocument);
    void update(const DOMString& fileName);
    Putter& copy() { return *(new Putter(*this)); }

  private:
    bool toConsole_;
    DOMString destPath_, destSpec_, typeString_;
    Pointer<Dumper> dumper_;
    Char separator_; // used for csv output

    void setSpecs(const DOMString& destString);
    void setDumper(bool update);
    void setConsoleDumper();
  };
}

#endif
