/***************************************************************************
                          reader.h  -  description
                             -------------------
    begin                : Sat Jan 24 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef READER_H
#define READER_H

#include <string>
#include <iostream>
#include <fstream>
#include "pointer.h"
#include "definitions.h"
#include "domstring.h"
#include "characterreader.h"
#include "inputstream.h"
#include "characterconverter.h"
#include "value.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Reader: public CharacterReader {
  public:
    Reader(bool isConsole = true);
    Reader(const URL& url);

    static Reader KeyBd;

    void setEncoding(Encoding encoding);
    int nextChar() { if (!input_) { if (inputStream_) inputStream_->close(); return -1; }
      if (*ungot_) ungot_ = false;
      else {
        int c = converter_->get(input_);
        while (c == 13) // skip over CR
          c = converter_->get(input_);
        lastChar_ = c; }
      return *lastChar_; }
    void unget() { ungot_ = true; }
    bool isValid() { return *input_; }
    URL getURL() { return inputStream_->url_; }
    Reader& copy() { return *(new Reader(*this)); }

  protected:
    Pointer<InputStream> inputStream_;
    Pointer<CharacterConverter> converter_;
    std::istream *input_;
    Value<bool> ungot_;
    Value<int> lastChar_;
    bool isDefault_;

    void openFile();
    void skipBOM();
  };

  typedef Reader rd;
}

#endif
