/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDREFORMER_H
#define LIMPIDREFORMER_H

#include "documentprocessor.h"
#include "domutils.h"

namespace limpid {

class NodeList;
class Element;
/**
	@author John Redmond <john_redmond@optusnet.com.au>
*/
class Reformer: public DocumentProcessor, public DOMUtils {

public:
  Reformer() {}
  Document& processDocument(Document& document);
  Reformer& copy() { return *(new Reformer(*this)); }
private:

  void upgrade(Document& document);
  void reformTable(Element& tableElement);
  void reformList(Element& listElement);
  void reformDefinitionList(Element& listElement);
  void reformAnchor(Element& anchorElement);
  void reformPreText(Element& preElement);
  void reformMetaText(Element& metaElement);
  void expandMatches(Document& document, NodeList& matchList);
  void expandTable(Element& tableElement);
  void replaceRow(Element& bodyElement, Element& pElement);
  void replaceMixedContent(Document& document);
  void replaceText(Node& root);
};

}

#endif
