/***************************************************************************
                          reporter.h  -  description
                             -------------------
    begin                : Fri Jun 2 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef REPORTER_H
#define REPORTER_H

#include "documentprocessor.h"
#include "pointer.h"
#include "dtdconverter.h"
#include "validationprocessor.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Reporter : public DocumentProcessor  {
  public:
    Reporter();
    Reporter(const DOMString& validatorString);

    Document& processDocument(Document& document);
    void update(const DOMString&) {}
    void setSimple(bool simple) { validationProcessor_->setSimple(simple); }
    Reporter& copy() { return *(new Reporter(*this)); }

  private:
    DOMString validatorString_;
    Pointer<DTDConverter> dtdConverter_;
    Pointer<ValidationProcessor> validationProcessor_;
    bool defined_;
  };
}

#endif
