/***************************************************************************
                          rjparser.h  -  description
                             -------------------
    begin                : Sun Apr 9 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RJPARSER_H
#define RJPARSER_H

#include "parser.h"
#include "pointer.h"
#include "reader.h"
#include "tokenstream.h"
#include "node.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;

  class RJParser : public Parser  {
  public:
    RJParser(const DOMString& fileName);
    RJParser(const Reader& characterStream);

    Node& nextNode();
    RJParser& copy() { return *(new RJParser(*this)); }

  private:
    Pointer<Node> node_, contentNode_, endNode_;
    Pointer<Reader> reader_;
    Pointer<TokenStream> tis_;
    bool atStart_, inEntry_, hasContent_, atEnd_;
    DOMString line_, content_;

    void parseLine();
    bool setLine();
    void completeContentString(DOMString& contentString);
  };
}


#endif
