/***************************************************************************
                          romannumberformatter.cpp  -  description
                             -------------------
    begin                : Thu Jan 27 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "romannumberformatter.h"
#include "writer.h"

namespace limpid {

RomanNumberFormatter::RomanNumberFormatter() {
}

// this could be done more elegantly, using look-ups, but it does the job
DOMString RomanNumberFormatter::format(int number, bool upperCase) {
  DOMString resultString;

  while (number >= 1000) {  // work down through the thousands
    resultString += "M";
    number -= 1000;
  }

  if (number >= 900) {
    resultString += "CM";
    number -= 900;
  }
  else if (number >= 500) {
    resultString += "D";
    number -= 500;
  }
  else if (number >= 400) {
    resultString += "XD";
    number -= 400;
  }

  while (number >= 100) {  // work down through the hundreds
    resultString += "C";
    number -= 100;
  }

  if (number >= 90) {
    resultString += "XC";
    number -= 90;
  }
  else if (number >= 50) {
    resultString += "L";
    number -= 50;
  }
  else if (number >= 40) {
    resultString += "XL";
    number -= 40;
  }

  while (number >= 10) {  // work down through the tens
    resultString += "X";
    number -= 10;
  }

  if (number == 9) {
    resultString += "IX";
    number -= 9;
  }
  else if (number >= 5) {
    resultString += "V";
    number -= 5;
  }
  else if (number == 4) {
    resultString += "IV";
    number -= 4;
  }

  while (number) {
    resultString += "I";  // work down through the ones
    --number;
  }

  if (!upperCase) resultString.toLowerCase();

  return resultString;
}

}
