/***************************************************************************
 *   Copyright (C) 2007 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "rootstripper.h"
#include "element.h"

namespace limpid {

Document& RootStripper::processDocument(Document& document) {
  if (!document.getDocumentElement().isValid())
    return document; // surely not!

  while (document.getDocumentElement().getChildNodes().getLength() == 1) {
    Element& documentElement = document.getDocumentElement();

    Node& firstContent = documentElement.getFirstChild();
    document.replaceChild(firstContent, documentElement);
  }

  return document;
}

}
