/***************************************************************************
                          saver.cpp  -  description
                             -------------------
    begin                : Tue Jun 6 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "saver.h"
#include "node.h"
#include "document.h"
#include "domwriter.h"

namespace limpid {

Saver::Saver(const DOMString& destPath): destPath_(destPath), parentDocument_(0) {}

Node& Saver::process(Node& node) {
  return node; // save all the action for the finish()
}

void Saver::finish() {
  if (!destPath_.empty())
    DOMWriter(destPath_).write(*parentDocument_);
  else
    DOMWriter().write(*parentDocument_);
}

}
