/***************************************************************************
                          selectionmanager.h  -  description
                             -------------------
    begin                : Sat Sep 17 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SELECTIONMANAGER_H
#define SELECTIONMANAGER_H

#include <map>
#include <vector>
#include "template.h"
#include "xslresources.h"
#include "templatelist.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class SelectionManager {
  public:
    SelectionManager(bool isImported = false);
  	SelectionManager(bool isImported, const DOMString& modeString);

    void setResources(XSLResources& resources) { resources_ = resources; }
    Template& getCalledTemplate(const DOMString& calledName);
    Template& getMatchedTemplate(Node& node);
    void setMatchedTemplate(const DOMString& key, Template& tmp, bool isImported);

  private:
    typedef std::map<DOMString, TemplateList> CacheMap;

    Pointer<CacheMap> cachedTemplates_;
    XSLResources resources_;
    bool isImported_;
    DOMString modeString_;

    Template& getCachedTemplate(Node& node);
    void cachePossibleTemplates(Node& node);
    void collectTemplates(Node& node, TemplateList& templateList, bool isImported);
    bool isCached(const DOMString& nodeName) {
      return cachedTemplates_->find(nodeName) != cachedTemplates_->end(); }
  };
}

#endif
