/***************************************************************************
                          siblingstream.cpp  -  description
                             -------------------
    begin                : Fri Dec 19 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "siblingstream.h"
#include "writer.h"

namespace limpid {

SiblingStream::SiblingStream(bool forwd): forward(forwd), currentNode(0) {
}

SiblingStream::SiblingStream(Node& root, bool forwd):
      forward(forwd), currentNode(&root) {
}

Node& SiblingStream::nextNode() {
  if (!currentNode) return Node::failNode;
  else if (forward)
    currentNode = &currentNode->getNextSibling();
  else
    currentNode = &currentNode->getPreviousSibling();

  return *currentNode;
}

void SiblingStream::setRoot(const Node& root) {
  currentNode = &const_cast<Node &>(root);
}

}
