/***************************************************************************
                          singlestream.h  -  description
                             -------------------
    begin                : Mon May 24 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SINGLESTREAM_H
#define SINGLESTREAM_H

#include "nodesource.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class SingleStream : public NodeSource  {
    enum SingleType { SELF, PARENT, DOCUMENT };
  public:
  	SingleStream(const DOMString& type);

    Node& nextNode();
    void setRoot(const Node& root);
    SingleStream& copy() { return *(new SingleStream(*this)); }

    private:
      SingleType type_;
      Node *root_, *lastNode_;

      void configure(DOMString type);
  };
}

#endif
