/***************************************************************************
                          sizer.cpp  -  description
                             -------------------
    begin                : Mon Apr 21 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "sizer.h"
#include "writer.h"

namespace limpid {

Sizer::Sizer(bool vbose): totalSize(0), lastSize(0), totalNodes(0),
  multiples(0), totalAttrs(0), verbose(vbose) {
}

Node& Sizer::process(Node& node) {
  ++totalNodes;
  size_t copies = node.getRefCount();
  if (false && copies > 1) {
wrt::Console << copies << " COPIES OF " << node << " = " << &node << " " <<  &node.getParentNode() << " " << &node.getNextSibling() << wrt::endl;
    ++multiples;
  }

  int thisSize = node.getSize(); // this includes the size of attrs
  NamedNodeMap &attrs = node.getAttributes();
  int attrCount = attrs.getLength();

  if (verbose) {
    DOMString path = node.getPath();
    wrt::Console << "L." << node.getPosition();
    wrt::Console << ": " << "Type " << node.getNodeType();
    wrt::Console << ": " << path << ": Size: " << thisSize;
    wrt::Console << ", Copies: " << node.getRefCount() << wrt::endl;
    if (attrCount)
      reportAttributes(attrs);
  }

  lastSize = thisSize;
  totalSize += thisSize;
  totalAttrs += attrCount;

  return node;
}

void Sizer::reportAttributes(NamedNodeMap& attrs) {
  for (size_t i = 0; i < attrs.getLength(); i++) {
    Node& node = attrs.item(i);
    wrt::Console << "\tAttr: " << node.getNodeName() << ": Size: ";
    wrt::Console << node.getSize();
    wrt::Console << ", Copies: " << node.getRefCount() << wrt::endl;
  }
}

}
