/***************************************************************************
                          sizer.h  -  description
                             -------------------
    begin                : Mon Apr 21 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIZER_H
#define SIZER_H

#include "processor.h"
#include "namednodemap.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Sizer : public Processor  {
  public:
  	Sizer(bool vbose = false);

    int getTotalSize() { return totalSize; }
    int getLastSize() { return lastSize; }
    int getTotalNodes() { return totalNodes; }
    int getTotalAttrs() { return totalAttrs; }
    int getMultiples() { return multiples; }
    void setVerbose(bool flag) { verbose = flag; }
    Node& process(Node& node);
    void reportAttributes(NamedNodeMap& attrs);
    Sizer& copy() { return *(new Sizer(*this)); }

  protected:
    int totalSize, lastSize, totalNodes, multiples, totalAttrs;
    bool verbose;
  };
}
#endif
