/***************************************************************************
                          sorter.h  -  description
                             -------------------
    begin                : Sat Jan 29 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SORTER_H
#define SORTER_H

#include "nodelist.h"
#include "nodeset.h"
#include "sorterpolicy.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class SorterPolicy;

  class Sorter {
  public:
  	Sorter();
    Sorter(SorterPolicy& sorterPolicy);

   void doSort(NodeList& nodeList) { sorterPolicy_->process(nodeList.getData()); }
   void doSort(NodeSet& nodeSet) { sorterPolicy_->process(nodeSet.getData()); }
   void setPolicy(SorterPolicy& sorterPolicy);

   protected:
    Pointer<SorterPolicy> sorterPolicy_;
  };
}
#endif
