/***************************************************************************
                          sorttemplate.h  -  description
                             -------------------
    begin                : Sun Jan 30 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SORTTEMPLATE_H
#define SORTTEMPLATE_H

#include "template.h"
#include "pointer.h"
#include "expressionsorter.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;
  class SortTemplate : public Template  {
  public:
  	SortTemplate(const DOMString& selectString, const DOMString& typeString,
        const DOMString& orderString);

    bool process(XSLContext&);
    bool processNode(XSLContext& parentContext, Node&) { return process(parentContext); }
    SortTemplate& copy() { return *(new SortTemplate(*this)); }

  private:
    Pointer<ExpressionSorter> sorter_;
  };
}

#endif
