/***************************************************************************
                          specifiedattributestemplate.h  -  description
                             -------------------
    begin                : Tue Mar 22 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPECIFIEDATTRIBUTESTEMPLATE_H
#define SPECIFIEDATTRIBUTESTEMPLATE_H

#include <set>
#include <vector>
#include "compoundtemplate.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class SpecifiedAttributesTemplate : public Template  {
  public:
  	SpecifiedAttributesTemplate();

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);
    void addAttribute(CompoundTemplate& keyTemplate, CompoundTemplate& valueTemplate);
    SpecifiedAttributesTemplate& copy() { return *(new SpecifiedAttributesTemplate(*this)); }

  private:
    typedef std::pair<CompoundTemplate, CompoundTemplate> AttributePair;
    typedef std::vector<AttributePair> AttributeList;
    typedef std::set<XPathString> KeySet;

    Pointer<AttributeList> attributes_;
  };
}

#endif
