/***************************************************************************
                          step.h  -  description
                             -------------------
    begin                : Thu Jun 10 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STEP_H
#define STEP_H

#include <vector>
#include "nodesetprocessor.h"
#include "nodesource.h"
#include "test.h"
#include "predicate.h"
#include "pointer.h"
#include "xslcontext.h"
/**
  *@author John Redmond
  */

namespace limpid {
  class Step : public NodeSetProcessor  {
  public:
  	Step();

    NodeSet processNodeSet(NodeSet& nodeSet, Context& context, bool exact = true);

    void setStream(NodeSource& strm) { stream_ = &strm.copy(); }
    void setTest(Test& tst) { test_ = &tst.copy(); }
    void appendPredicate(Predicate& predicate) {
      predicates_->push_back(&predicate.copy()); }

    Step& copy() { return *(new Step(*this)); }

    private:
      typedef Pointer<Predicate> PredicateFilter;
      typedef std::vector<PredicateFilter> Predicates;

      Pointer<NodeSource> stream_;
      Pointer<Test> test_;
      Pointer<Predicates> predicates_;
      XSLContext context_;


      void processNode(Node& root, NodeSet& resultSet, Context& context);
      NodeSet applyFilters(NodeSet& testSet, Context& context);
  };
}

#endif
