/***************************************************************************
                          stepper.h  -  description
                             -------------------
    begin                : Tue Apr 18 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STEPPER_H
#define STEPPER_H

#include <deque>
#include "processor.h"
#include "document.h"
#include "domstring.h"
#include "stylesheet.h"
#include "builder.h"

/**
  *@author John Redmond
  */


namespace limpid {
  class Stepper : public Processor  {
  public:
    Stepper(const DOMString& xslPath, bool useBuilding = false);
    Stepper(const DOMString& xslPath, const DOMString& outputPath,
        bool useBuilding = true);
    Stepper& copy() { return *(new Stepper(*this)); }
    Node& process(Node& node);
    void start();
    void finish();
    
  private:
    typedef std::deque<Node *> NodeStack;

    Pointer<CharacterWriter> writer_;
    Pointer<StyleSheet> styleSheet_;
    Pointer<NodeStack> nodeStack_;
    Element beginNode_, endNode_;
    bool useBuilding_;
  };
}


#endif
