/***************************************************************************
                          stringcomparison.h  -  description
                             -------------------
    begin                : Sat Jun 18 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGCOMPARISON_H
#define STRINGCOMPARISON_H

#include "parentcomponent.h"
#include "xpathstring.h"
#include "boolean.h"
#include "number.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;
  class XPathString;
  class Boolean;
  class Context;

  class StringComparison : public ParentComponent  {
  public:
  	StringComparison();
    StringComparison(const DOMString& typeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    StringComparison& copy() { return *(new StringComparison(*this)); }

  protected:
    bool logic_;

    bool comparePair(XPathExpression& first, XPathExpression& second, Context& context);
    bool compareFirstNodeSet(XPathExpression& first, const XPathString& secondString,
        Context& context);
    bool compareSecondNodeSet(const XPathString& firstString, XPathExpression& secodn,
        Context& context);
    bool compareNodeSets(XPathExpression& firstString, XPathExpression& second,
        Context& context);
    bool compareStrings(const DOMString& firstString, const DOMString& secondString) {
      return (firstString == secondString) == logic_; }
  };
}

#endif
