/***************************************************************************
                          stringgenerator.h  -  description
                             -------------------
    begin                : Fri May 28 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************

 This is a real grap-bag of functions for string procession. I know very well that it
 goes against the object Way, but I have done it to limit the proliferation of XPath
 classes. The included functions are:
    enum GeneratorType { STRING, SUBSTRING_BEFORE, SUBSTRING_AFTER,
      SUBSTRING, CONCAT, NORMALIZE_SPACE };
*/

#ifndef STRINGGENERATOR_H
#define STRINGGENERATOR_H

#include "parentcomponent.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "context.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class StringGenerator : public ParentComponent  {
  public:
    enum GeneratorType {
      STRING, NORMALIZE_SPACE, ESCAPE_XML, ESCAPE_TEX, // 1 param
      SUBSTRING, SUBSTRING_BEFORE, SUBSTRING_AFTER, // 2 params
      CONCAT // >= 2 params
    };

   StringGenerator(const DOMString& type);

    Boolean getBoolean(Context& context) {
      return getString(context).getBoolean(context); }
    XPathString getString(Context& context);
    Number getNumber(Context& context) {
      return getString(context).getNumber(context); }
    Expr eval(Context& context) { return getString(context); }

    StringGenerator& copy() { return *(new StringGenerator(*this)); }

  private:
    GeneratorType type_;

    void setType(const DOMString& typeString);
    XPathString childString(Context& context);

    XPathString substring(DOMString& firstString, Context& context);
    XPathString substringBefore(DOMString& firstString, Context& context);
    XPathString substringAfter(DOMString& firstString, Context& context);
    XPathString concat(DOMString& firstString, Context& context);
  };
}

#endif
