/***************************************************************************
                          stringpairmap.cpp  -  description
                             -------------------
    begin                : Mon May 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "stringpairmap.h"

namespace limpid {

StringPairMap::StringPairMap(): map_(new SPMap) {
}

void StringPairMap::addEntry(const DOMString& key, const DOMString& first,
    const DOMString& second) {
  map_->insert(EntryPair(key, DataPair(first, second)));
}

bool StringPairMap::hasKey(const DOMString& key) {
  return map_->find(key) != map_->end();
}

DOMString StringPairMap::getFirst(const DOMString& key) {
  SPMap::iterator p = map_->find(key);
  if (p == map_->end()) return "";
  else return p->second.first;
}

DOMString StringPairMap::getSecond(const DOMString& key) {
  SPMap::iterator p = map_->find(key);
  if (p == map_->end()) return "";
  else return p->second.second;
}

}

