/***************************************************************************
                          stringpairmap.h  -  description
                             -------------------
    begin                : Mon May 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGPAIRMAP_H
#define STRINGPAIRMAP_H

#include <map>
#include "domstring.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class StringPairMap {
  public:
  	StringPairMap();

   void addEntry(const DOMString& key, const DOMString& first, const DOMString& second);
   bool hasKey(const DOMString& key);
   DOMString getFirst(const DOMString& key);
   DOMString getSecond(const DOMString& key);
   size_t getLength() { return map_->size(); }

  private:
    typedef std::pair<DOMString, DOMString> DataPair;
    typedef std::pair<const DOMString, DataPair> EntryPair;
    typedef std::map<const DOMString, DataPair> SPMap;

    Pointer<SPMap> map_;
  };
}

#endif
