/***************************************************************************
                          stringstream.h  -  description
                             -------------------
    begin                : Wed Jan 28 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGSTREAM_H
#define STRINGSTREAM_H

#include "domstring.h"
#include "characterreader.h"
#include "writer.h"

/**
  *@author John Redmond
  */

namespace limpid {

  class StringReader: public CharacterReader {
  public:
    StringReader(const DOMString& src);

    int nextChar() { if (index >= limit) return -1; return source[index++]; }
    void unget() { if (index) --index; }
    bool isValid() { return index < limit; }
    void reset() { index = 0; }
    void setEncoding(Encoding) {};
    URL getURL();
    StringReader& copy() { return *(new StringReader(*this)); }


  protected:
    DOMString source;
    size_t index, limit;
  };
}

#endif
