/***************************************************************************
                          stringtemplate.h  -  description
                             -------------------
    begin                : Wed Oct 20 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGTEMPLATE_H
#define STRINGTEMPLATE_H

#include "template.h"
#include "xslcontext.h"
#include "text.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class StringTemplate : public Template  {
  public:
    StringTemplate(const DOMString& string): Template(string) { isText_ = true; }

    bool process(XSLContext& context) {
      context.getWriter() << matchValue_; return true; }
    bool processNode(XSLContext&, Node& node) {
      Text text(matchValue_); node.appendChild(text); return true; }
    XPathString getString(XSLContext&) { return matchValue_; }
    StringTemplate& copy() { return *(new StringTemplate(*this)); }
  };
}


#endif
