/***************************************************************************
                          stringtester.h  -  description
                             -------------------
    begin                : Sat May 29 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGTESTER_H
#define STRINGTESTER_H

#include "parentcomponent.h"
#include "collectorcomponent.h"
#include "context.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Boolean;
  class XPathString;
  class Number;
  class Context;
  class DOMString;

  class StringTester : public ParentComponent  {
  public:
    enum MatchType { EQUALS, CONTAINS, STARTS_WITH, LANG };

  	StringTester(MatchType matchType = EQUALS, bool logic = true);
    StringTester(const DOMString& typeString);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context) {
      return getBoolean(context).getString(context); }
    Number getNumber(Context& context) {
      return getBoolean(context).getNumber(context); }
    Expr eval(Context& context) { return getBoolean(context); }

    StringTester& copy() { return *(new StringTester(*this)); }

  protected:
    bool logic_;
    MatchType matchType_;

    bool testLang(Context& context);
    bool comparePair(XPathExpression& first, XPathExpression& second, Context& context);
    bool compareNodeSets(CollectorComponent& first, CollectorComponent& second,
        Context& context);
    bool compareFirstNodeSet(CollectorComponent& first, XPathExpression& second,
        Context& context);
    bool compareSecondNodeSet(XPathExpression& first, CollectorComponent& second,
        Context& context);
    virtual bool compareStrings(DOMString& first, DOMString& second);

    void setType(const DOMString& typeString);
  };
}
#endif
