/***************************************************************************
                          stringtranslator.h  -  description
                             -------------------
    begin                : Sat Jun 25 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGTRANSLATOR_H
#define STRINGTRANSLATOR_H

#include <map>
#include "definitions.h"
#include "xpathexpression.h"
#include "expr.h"
#include "xpathstring.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Expr;
  class Boolean;
  class Number;
  class Context;

  class StringTranslator : public XPathExpression  {
  public:
  	StringTranslator(Expr& expr, const DOMString& from, const DOMString& to);

    Boolean getBoolean(Context& context) {
      return getString(context).getBoolean(context); }
    XPathString getString(Context& context);
    Number getNumber(Context& context) {
      return getString(context).getNumber(context); }
    Expr eval(Context& context) { return getString(context); }
    bool isValid() { return true; }

    StringTranslator& copy() { return *(new StringTranslator(*this)); }

  private:
    typedef std::map<Char, Char> CharMap;
    
    Expr expr_;
    Pointer<CharMap> charMap_;

    void setupMap(const DOMString& fromString, const DOMString& toString);
  };
}

#endif
