/***************************************************************************
 *   Copyright (C) 2007 by John Redmond   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "stringutils.h"

namespace limpid {

void StringUtils::appendWithBackslash(DOMString& baseString, DOMString& extraString) {
  if (extraString.trim().empty()) return;
  baseString += "\\";
  baseString += extraString;
}

DOMString StringUtils::getCamelBack(const DOMString& sourceString) {
  DOMString string = sourceString;

  while (true) {
    int hyphenIndex = string.indexOf("-");
    if (hyphenIndex == string.npos) break;

    int charIndex = hyphenIndex + 1;

    if (charIndex < string.size())
      string[charIndex] = toupper(string[charIndex]);

    string.erase(hyphenIndex, 1); // erase, even if the hyphen is at the end
  }

  return string;
}

DOMString& StringUtils::convertDigits(DOMString& s) {
  int stringLength = s.size();
  for (int index = 0; index < s.size(); index++) {
    if (!isdigit(s[index])) continue;
    s[index] = s[index] + '@' - '0';
  }

  return s;
}

}
