/***************************************************************************
                          stringwriter.h  -  description
                             -------------------
    begin                : Thu Jun 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef STRINGWRITER_H
#define STRINGWRITER_H

#include "characterwriter.h"
#include "pointer.h"
#include "domstring.h"
#include "url.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class StringWriter : public CharacterWriter  {
  public:
    StringWriter();

    void setEncoding(Encoding) {};
    void setEncoding(const DOMString&) {}
    int putChar(int c) { outputString_->push_back(c); return true; }
    void clear() { outputString_->clear(); }
    bool isValid() { return true; }
    URL getURL() { return URL("string://"); }
    DOMString getString() { return *outputString_; }
    StringWriter& copy() { return *(new StringWriter(*this)); }

  private:
    Pointer<DOMString> outputString_;
  };
}

#endif
