/***************************************************************************
                          sxfparser.h  -  description
                             -------------------
    begin                : Thu May 25 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SXFPARSER_H
#define SXFPARSER_H

#include "parser.h"
#include "pointer.h"
#include "reader.h"
#include "tokenstream.h"
#include "node.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;

  class SXFParser : public Parser  {
  public:
    SXFParser(const DOMString& fileName);
    SXFParser(const Reader& characterStream);

    Node& nextNode();
    SXFParser& copy() { return *(new SXFParser(*this)); }

  private:
    Pointer<Node> node_, contentNode_, endNode_;
    Pointer<Reader> reader_;
    Pointer<TokenStream> tis_;
    bool hasContent_, hasEnd_;
    size_t depth_;
    DOMString line_, content_;
    int lineNo_;
    DOMString delimiterString_;

    DOMString getContentString();
  };
}

#endif
