/***************************************************************************
                          systempropertygenerator.cpp  -  description
                             -------------------
    begin                : Mon May 16 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "systempropertygenerator.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "nodeset.h"
#include "context.h"
#include "documenttype.h"
#include "entity.h"
#include "namednodemap.h"

namespace limpid {

SystemPropertyGenerator::SystemPropertyGenerator() {}

Boolean SystemPropertyGenerator::getBoolean(Context&) {
  return false;
}

XPathString SystemPropertyGenerator::getString(Context& context) {
  if (!getLength()) return "unknown uri";

  XPathString nameString = getItem(0).getString(context);

  if (nameString == "xsl:version") return "1.0";
  if (nameString == "xsl:vendor") return "Limpid";
  if (nameString == "xsl:vendor-url") return "www.limpidsoft.com";

  nameString += " is an unknown property in Limpid";
  return nameString;
}

Number SystemPropertyGenerator::getNumber(Context&) { return 0; }

NodeSet SystemPropertyGenerator::getNodeSet(Context&, bool) {
  NodeSet resultSet;
  return resultSet;
}

}


