/***************************************************************************
                          systempropertygenerator.h  -  description
                             -------------------
    begin                : Mon May 16 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
                          systempropertygenerator.h  -  description
                             -------------------
    begin                : Mon May 16 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SYSTEMPROPERTYGENERATOR_H
#define SYSTEMPROPERTYGENERATOR_H

#include "parentcomponent.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Boolean;
  class XPathString;
  class DOMString;
  class Number;
  class Context;
  class NodeSet;

  class SystemPropertyGenerator: public ParentComponent {
    public:
    	SystemPropertyGenerator();

      Boolean getBoolean(Context& context);
      XPathString getString(Context& context);
      Number getNumber(Context& context);
      NodeSet getNodeSet(Context& context, bool exact = true);
      Expr eval(Context& context) { return getString(context); }

      double getPriority() { return -1000; }
      bool isNodeSet() { return false; }
      bool isBoolean() { return false; }
      SystemPropertyGenerator& copy() { return *(new SystemPropertyGenerator(*this)); }
  };

}

#endif
