/***************************************************************************
                          templateexpr.cpp  -  description
                             -------------------
    begin                : Sat Oct 1 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "templateexpr.h"
#include "stringwriter.h"
#include "xslcontext.h"

namespace limpid {

TemplateExpr::TemplateExpr(CompoundTemplate& templates): templates_(templates) {}

XPathString TemplateExpr::getString(Context& parentContext) {
  XSLContext context;
  context.setParent(static_cast<XSLContext &>(parentContext));

  StringWriter writer;
  context.setWriter(writer);

  templates_.process(context);
  return writer.getString();
}

inline Boolean TemplateExpr::getBoolean(Context& parentContext) {
  return static_cast<int>(getString(parentContext).size());
}

inline Expr TemplateExpr:: eval(Context& parentContext) {
  return getString(parentContext);
}

inline Number TemplateExpr::getNumber(Context& parentContext) {
  return Number(getString(parentContext));
}

}
