/***************************************************************************
                          templateexpr.h  -  description
                             -------------------
    begin                : Sat Oct 1 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEMPLATEEXPR_H
#define TEMPLATEEXPR_H

#include "xpathexpression.h"
#include "compoundtemplate.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class TemplateExpr : public XPathExpression  {
  public:
  	TemplateExpr(CompoundTemplate& templates);

    Boolean getBoolean(Context& context);
    XPathString getString(Context& parentContext);
    Number getNumber(Context& context);
    Expr eval(Context& context);

    bool isValid() { return true; }

    TemplateExpr& copy() { return *(new TemplateExpr(*this)); }

  private:
    CompoundTemplate templates_;
  };
}

#endif
