/***************************************************************************
                          templatelauncher.h  -  description
                             -------------------
    begin                : Mon Sep 19 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEMPLATELAUNCHER_H
#define TEMPLATELAUNCHER_H

/**
  *@author John Redmond
  */

namespace limpid {
  class SelectionManager;
  class DefaultTemplate;
  class XSLContext;
  class ExpressionMap;
  class Node;

  class TemplateLauncher {
  public:
    // this first constructor is used by StyleSheet
    TemplateLauncher(SelectionManager& selectionManager, DefaultTemplate& defaultTemplate);
    // this constructor is used by ApplyTemplate and CallTemplate
    TemplateLauncher(SelectionManager& selectionManager,
      DefaultTemplate& defaultTemplate, ExpressionMap& parameters);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);

  private:
    SelectionManager* selectionManager_;
    DefaultTemplate* defaultTemplate_;
    ExpressionMap* parameters_;
    bool passParams_;
  };
}

#endif
