/***************************************************************************
                          duplicate.h  -  description
                             -------------------
    begin                : Fri Oct 29 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEMPLATELIST_H
#define TEMPLATELIST_H

#include <vector>
#include "pointer.h"
#include "template.h"
#include "node.h"
//#include "xslcontext.h"

namespace limpid {
    class Template;
    class XSLContext;
  class TemplateList {
  public:
    TemplateList();

    void addTemplate(Template& tmp);
    size_t getLength() { return templates_->size(); }
    Template& getItem(size_t index);
    bool process(XSLContext& context);
    bool processNode(XSLContext& context, Node& node);
    void clear() { templates_->clear(); }
    void doSort(bool verbose = false);// { stable_sort(templates_->begin(), templates_->end(), comparator_); }
//    for an older compiler, it may be necessary to use the following definition:
//    void doSort() {
//      stable_sort(templates->begin(), templates->end(), CompTemplates());
//    }

  private:
    class CompTemplates {
    public:
    	CompTemplates() {}

      bool operator()(const Template* lhs, const Template* rhs) const {
///wrt::Errors << lhs->getPriority() << ": " << lhs->getMatchValue()  << " COMP " << rhs->getPriority() << ": " << rhs->getMatchValue() << wrt::endl;
        return lhs->getPriority() >= rhs->getPriority(); // want reverse order
      }
    };

    typedef Pointer<Template> TemplatePointer;
    typedef std::vector<Template *> Templates;
    typedef std::vector<TemplatePointer> TemplatePointers; // shadow the sortable pointers
// this is a crude approach, and must be fixed -- later

    Pointer<Templates> templates_;
    Pointer<TemplatePointers> templatePointers_;
    static CompTemplates comparator_;

    void list();
  };
}

#endif

