/***************************************************************************
                          templatestream.cpp  -  description
                             -------------------
    begin                : Sun Aug 7 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "templatestream.h"

namespace limpid {

TemplateStream::TemplateStream(const XSLResources& resources, bool imported) {
  if (imported) templates_ = resources.importedMatchedMap_;
  else templates_ = resources.matchedMap_;
  p_ = templates_->rbegin();
  pend_ = templates_->rend();
}

Template& TemplateStream::nextTemplate() {
  if (p_ == pend_) return Template::failTemplate;
  return *(p_++->second);
}

}
