/***************************************************************************
                          templatestream.h  -  description
                             -------------------
    begin                : Sun Aug 7 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEMPLATESTREAM_H
#define TEMPLATESTREAM_H

#include <map>
#include "xslresources.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

using std::map;

namespace limpid {
class TemplateStream {
  public:
  	TemplateStream(const XSLResources& resources, bool imported = false);
    Template& nextTemplate();

  private:
    typedef std::map<DOMString, Pointer<Template> > NamedTemplateMap;

    Pointer<NamedTemplateMap> templates_;
    NamedTemplateMap::reverse_iterator p_, pend_; // these are not managed
  };
}

#endif
