/***************************************************************************
                          test.h  -  description
                             -------------------
    begin                : Wed Oct 22 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEST_H
#define TEST_H

#include <iostream>
#include "copied.h"
#include "node.h"
/**
  *@author John Redmond
  */

namespace limpid {
  class Test: public Copied {
  public:
  	Test() {}

    virtual bool test(Node&) { return true; }
    virtual Node& start(Node& node) { return node; }
    virtual bool isTerminal() { return false; }
    Test& copy() { return *(new Test(*this)); }
  };
}
#endif

/**
  Test evaluates a node and returns a boolean. Test is the ancestral class of all tests,
  and always returns true. It is not specified as an abstract class so that it can be
  instantiated as a dummy object in any of the aggregating or composing classes which
  require a test.
**/
