/***************************************************************************
                          text.h  -  description
                             -------------------
    begin                : Wed Sep 10 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEXT_H
#define TEXT_H

#include "characterdata.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Text : public CharacterData  {
  public:
    Text();
  	Text(const DOMString& data);
    Text(const Text&);
    Text& operator=(const Text&);

  //DOM:
    DOMString getValue() const { return getNodeValue(); }
    DOMString getNodeValue() const;
    Text splitText(size_t offset);

  //non-DOM:
    DOMString getRawValue() const { return getData(); }
    Node& cloneNode(bool deep = false) const;
    DOMString getDisplayString() const;

  protected:
    Text(NodeType nodeType, const DOMString&); // for use by CDATASection constructor

    Text& copy() { return *(new Text(*this)); }
  };
}
#endif
