/***************************************************************************
 *   Copyright (C) 2006 by root   *
 *   john_redmond@optusnet.com.au   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "texteditor.h"

namespace limpid {

TextEditor::TextEditor(const DOMString& targetString): theString(targetString) {}

DOMString& TextEditor::update(DOMString& oldString) {
  oldString.swap(theString);
  return oldString;
}

void TextEditor::replace(const DOMString& oldString, const DOMString& newString) {
  theString.change(oldString, newString);
}

void TextEditor::remove(const DOMString& oldString) {
    size_t index = theString.find(oldString, index);
    if (index != DOMString::npos) 
      theString.remove(index, oldString.size());
}

void TextEditor::removeAll(const DOMString& oldString) {
  size_t index = 0;

  while (true) {
    index = theString.find(oldString, index);
    if (index == DOMString::npos) return;

    theString.remove(index, oldString.size());
  }
}

}
