/***************************************************************************
 *   Copyright (C) 2007 by root                                            *
 *   john_redmond@optusnet.com.au                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "domutils.h"
#include "textstripper.h"
#include "nodestream.h"
#include "liststream.h"
#include "siblingstream.h"
#include "nodelist.h"
#include "element.h"

namespace limpid {

Document& TextStripper::processDocument(Document& inputDocument) {
  NodeList textList;
  NodeStream nodeStream(inputDocument.getDocumentElement());

  // collect a list of all the text nodes
  while (true) {
    Node& node = nodeStream.nextNode();
    if (!node.isValid()) break;

    if (node.getNodeType() == Node::TEXT_NODE)
      textList.addNode(node);
  }

  // remove the text nodes from the document
  ListStream textStream(textList);

  while (true) {
    Node& node = textStream.nextNode();
    if (!node.isValid()) break;

    node.getParentNode().removeChild(node);
  }

  return inputDocument;
}


}
