/***************************************************************************
                          texttemplate.cpp  -  description
                             -------------------
    begin                : Mon Jun 27 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "texttemplate.h"
#include "xpathstring.h"
#include "xslcontext.h"
#include "text.h"

namespace limpid {

TextTemplate::TextTemplate(const Expr& contentExpr, bool resolveText):
    expr_(contentExpr), resolveText_(resolveText) {
  isText_ = true;
}

bool TextTemplate::process(XSLContext& parentContext) {
  XPathString result = expr_.getString(parentContext);
  result.resolveEntities();
  if (resolveText_)
    result.resolveBra();

  parentContext.getWriter() << result;

  return true;
}

bool TextTemplate::processNode(XSLContext& parentContext, Node& node) {
  XPathString result = expr_.getString(parentContext);
  result.resolveEntities();
  if (resolveText_)
    result.resolveBra();

  Text text(result);
  node.appendChild(text);

  return true;
}

}
