/***************************************************************************
                          texttemplate.h  -  description
                             -------------------
    begin                : Mon Jun 27 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEXTTEMPLATE_H
#define TEXTTEMPLATE_H

#include "template.h"
#include "expr.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class XPathString;
  class Number;
  class Boolean;
  class XSLContext;
  class Node;

  class TextTemplate : public Template  {
  public:
  	TextTemplate(const Expr& contentExpr, bool resolveText);

    bool process(XSLContext&);
    bool processNode(XSLContext& context, Node& node);
    TextTemplate& copy() { return *(new TextTemplate(*this)); }

  private:
    Expr expr_;
    bool resolveText_;
  };
}

#endif
