/***************************************************************************
                          timer.h  -  description
                             -------------------
    begin                : Sat Jan 24 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TIMER_H
#define TIMER_H

#include <time.h>
#include "definitions.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class DOMString;

  class Timer {
  public:
  	Timer();
  	~Timer();

    void reset();
    void report();
    void report(const DOMString& message);
  private:
    time_t start_;

#ifdef _WINDOWS_
    time_t getTime() { return (clock() - start_); }
#else
    time_t getTime() { return (clock() - start_) / 1000; }
#endif
  };
}
#endif
