/***************************************************************************
                          tokenhandler.cpp  -  description
                             -------------------
    begin                : Wed May 26 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "tokenhandler.h"
#include "writer.h"

namespace limpid {

TokenHandler::TokenHandler(): tokenIndex(0), markedIndex(0) {
}

void TokenHandler::addToken(const DOMString& token) {
  tokens.push_back(token);
}

DOMString& TokenHandler::nextToken() {
  if (tokenIndex < tokens.size())
    return tokens.at(tokenIndex++);
  else return failToken;
}

DOMString& TokenHandler::peekToken(int offset) {
  if (tokenIndex + offset < tokens.size() && tokenIndex >= 0)
    return tokens.at(tokenIndex + offset);
  else return failToken;
}

void TokenHandler::bumpToken(size_t step) {
  size_t newIndex = tokenIndex + step;
  if (newIndex >= tokens.size())
    tokenIndex = tokens.size();
  else
    tokenIndex = newIndex;
}

void TokenHandler::list() {
  size_t size = tokens.size();
  for (size_t index = 0; index < size; ++index)
wrt::Console << tokens.at(index) << wrt::endl;
}

}
