/***************************************************************************
                          tokenhandler.h  -  description
                             -------------------
    begin                : Wed May 26 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TOKENHANDLER_H
#define TOKENHANDLER_H

#include <vector>
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class TokenHandler {
  public:
  	TokenHandler();
    // rule of three is OK

    void addToken(const DOMString& token);
    DOMString& nextToken();
    DOMString& peekToken(int offset = 0);
    void ungetToken() { if (tokenIndex) --tokenIndex; }
    void bumpToken(size_t step = 1);
    void markPosition() { markedIndex = tokenIndex; }
    void resumePosition() { tokenIndex = markedIndex; }
    void reset() { tokenIndex = 0; }
    void list();

   private:
    typedef std::vector<DOMString> TokenList;

    DOMString failToken;
    TokenList tokens;
    int tokenIndex, markedIndex;

  };
}

#endif
