/***************************************************************************
                          traverser.h  -  description
                             -------------------
    begin                : Fri Apr 18 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TRAVERSER_H
#define TRAVERSER_H

#include "endnode.h"
#include "nodelist.h"
#include "processor.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Traverser : public Processor  {
  public:
    Traverser(Processor& processor, bool processEnds = true,
      bool processPrePost = true);

    Node& traverse(Node& node) { return process(node); }
    NodeList& traverse(NodeList& nodes) { return process(nodes); }

    Node& process(Node& node);
    NodeList& process(NodeList& nodes);

   private:
    Processor& processor_;
    EndNode endNode_;
    bool processEnds_, processPrePost_;

    Node& processNode(Node& node);

    void copyContent(Traverser& refTraverser);
    void deleteContent();
  };
}
#endif
