/***************************************************************************
                          unparsedurigenerator.cpp  -  description
                             -------------------
    begin                : Mon May 16 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "unparsedurigenerator.h"
#include "boolean.h"
#include "xpathstring.h"
#include "number.h"
#include "nodeset.h"
#include "context.h"
#include "documenttype.h"
#include "entity.h"
#include "namednodemap.h"

namespace limpid {

UnparsedURIGenerator::UnparsedURIGenerator() {}

Boolean UnparsedURIGenerator::getBoolean(Context&) {
  return false;
}

XPathString UnparsedURIGenerator::getString(Context& context) {
  if (!getLength()) return "no uri";

  XPathString nameString = getItem(0).getString(context);
  DocumentType& docType = context.getNode().getOwnerDocument().getDoctype();
  Node& entityNode = docType.getUnparsedEntities().getNamedItem(nameString);

  if (!entityNode.isValid()) return "unknown uri";

  Entity& entity = static_cast<Entity &>(entityNode);
  DOMString idString = entity.getSystemId();
  if (idString.empty())
    idString = entity.getPublicId();

  return idString;
}

Number UnparsedURIGenerator::getNumber(Context&) { return 0; }

NodeSet UnparsedURIGenerator::getNodeSet(Context&, bool) {
  NodeSet resultSet;
  return resultSet;
}

}
