/***************************************************************************
                          url.h  -  description
                             -------------------
    begin                : Sat Nov 1 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef URL_H
#define URL_H

#include <fstream>
//#include <iostream>
#include <string>
#include "domstring.h"
#include "iobase.h"
#include "pointer.h"

//class InputStream;

/**
  *@author John Redmond
  */

namespace limpid {
  class URL: public IOBase {
  public:
    URL(bool toConsole = true);
    URL(const DOMString& urlString);
    explicit URL(const DOMString& refPath, const DOMString& fileName);
    URL(const URL& baseURL, const DOMString& fileName);

    Protocol getProtocol() { return protocol_; }
    DOMString getPath() const { return path_; }
    DOMString getBasePath() const { return basePath_; }
    DOMString getFragmentPath() const { return fragmentPath_; }
    std::istream& getInput();
    std::ostream& getOutput();
    bool isDefault() const { return protocol_ == CONSOLE || protocol_ == ERRORS; }
    bool isValid() const { return valid_; }

  protected:
    Protocol protocol_;
    DOMString path_, basePath_, fragmentPath_;
    Char delimiter_;
    bool valid_;

    void setContent(DOMString pathString);
    Char getDelimiter(DOMString& path);
    DOMString completeBasePath(DOMString refPath);
    void copyContent(const URL& refURL, const DOMString& fileName);
  };
}
#endif
