/***************************************************************************
                          utf16converter.h  -  description
                             -------------------
    begin                : Sat Jun 19 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTF16CONVERTER_H
#define UTF16CONVERTER_H

#include <iostream>
#include <fstream>
#include "characterconverter.h"

/**
  *@author John Redmond
  */

using std::istream;
using std::ostream;

namespace limpid {
    class UTF16Converter: public CharacterConverter {
    public:
    	UTF16Converter(bool bigEndian = true);
     // rule of three OK.

    int get(istream *ip);
    int put(int wchar, ostream *output);

    private:
    bool isBigEndian;

    unsigned long getWord(istream *ip);
    void putWord(unsigned int schar, ostream *output);
  };
}

#endif
