/***************************************************************************
                          utf8converter.h  -  description
                             -------------------
    begin                : Fri Jun 25 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTF8CONVERTER_H
#define UTF8CONVERTER_H

#include <iostream>
#include <fstream>
#include "definitions.h"
#include "characterconverter.h"

/**
  *@author John Redmond
  */

using std::istream;

namespace limpid {
  class UTF8Converter: public CharacterConverter {
  public:
  	UTF8Converter();
    // rule of three OK

    int get(std::istream *ip);
    int put(int wchar, std::basic_ostream<char> *output);
  private:
    wchar_t convertToWChar();
    wchar_t getWCharFrom2(unsigned char first, std::istream *input);
    wchar_t getWCharFrom3(unsigned char first, std::istream *input);
    wchar_t getWCharFrom4(unsigned char first, std::istream *input);
    wchar_t getWCharFrom5(unsigned char first, std::istream *input);
    wchar_t getWCharFrom6(unsigned char first, std::istream *input);
    size_t convertFromWChar();
  };
}
#endif
