/***************************************************************************
                          validationprocessor.h  -  description
                             -------------------
    begin                : Sat Nov 22 2003
    copyright            : (C) 2003 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VALIDATIONPROCESSOR_H
#define VALIDATIONPROCESSOR_H

#include "copied.h"
#include "element.h"
#include "processor.h"
#include "writer.h"
#include "charactervalidator.h"
#include "contentvalidator.h"
#include "attributevalidator.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class ValidationProcessor : public Processor  {
  public:
    ValidationProcessor();

    Node& process(Node& node);
    void setWriter(Writer& writer);
    void setSimple(bool simple) { simple_ = simple; }
    void applySchema(Document& schemaDocument);
    size_t getSize();
    ValidationProcessor& copy() { return *(new ValidationProcessor(*this)); }

  protected:
    Writer writer_;
    CharacterValidator characterValidator_;
    ContentValidator contentValidator_;
    AttributeValidator attributeValidator_;
    bool constrained_, simple_;;

    void validateElement(Node& node);
    void validateAttributes(Element& element, size_t lineNo);
    void validateText(Node& node);
  };
}
#endif
