/***************************************************************************
                          valuetemplate.h  -  description
                             -------------------
    begin                : Fri Oct 1 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VALUETEMPLATE_H
#define VALUETEMPLATE_H


#include "template.h"
#include "xslresources.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Node;

  class ValueTemplate: public Template  {
  public:
  	ValueTemplate(const DOMString& matchString, bool disableOutputEscaping = false);

    bool process(XSLContext& parentContext);
    bool processNode(XSLContext& parentContext, Node& node);

    void setResources(XSLResources& resources) { resources_ = resources; }
    ValueTemplate& copy() { return *(new ValueTemplate(*this)); }

  private:
    Expr expr_;
    XSLResources resources_;
    bool disableOutputEscaping_;
  };
}

#endif
