/***************************************************************************
                          variable.cpp  -  description
                             -------------------
    begin                : Thu Jun 17 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "variable.h"
#include "boolean.h"
#include "number.h"
#include "writer.h"
#include "expr.h"

namespace limpid {

Variable::Variable(const DOMString& val): key_(val) {}

XPathString Variable::getString(Context& context) {
  XPathString s = eval(context).getString(context);
  return s;
}

Number Variable::getNumber(Context& context) {
  return eval(context).getNumber(context);
}

Boolean Variable::getBoolean(Context& context) {
  return eval(context).getBoolean(context);
}

NodeSet Variable::getNodeSet(Context& context) {
  return eval(context).getNodeSet(context);
}

Expr Variable::eval(Context& context) {
  return context.getVariable(key_);
}

}


