/***************************************************************************
                          variable.h  -  description
                             -------------------
    begin                : Thu Jun 17 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARIABLE_H
#define VARIABLE_H

#include "xpathstring.h"
#include "context.h"

/**
  *@author John Redmond
  */
namespace limpid {
  class Expr;
  class NodeSet;

  class Variable : public XPathExpression  {
  public:
  	Variable(const DOMString& val);

    XPathString getString(Context& context);
    Number getNumber(Context& context);
    Boolean getBoolean(Context& context);
    NodeSet getNodeSet(Context& context);
    Expr eval(Context& context);

    bool isValid() { return true; }

    Variable& copy() { return *(new Variable(*this)); }

  private:
    DOMString key_;
  };

}

#endif
