/***************************************************************************
                          whitespacemanager.h  -  description
                             -------------------
    begin                : Wed Feb 9 2005
    copyright            : (C) 2005 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef WHITESPACEMANAGER_H
#define WHITESPACEMANAGER_H


/**
  *@author John Redmond
  */

#include <deque>
#include <set>
#include "xslutility.h"
#include "document.h"
#include "element.h"
#include "domstring.h"
#include "pointer.h"
#include "andtest.h"

namespace limpid {
  class WhitespaceManager: protected XSLUtility {
  public:
    WhitespaceManager();
  	WhitespaceManager(Document& document);

    void configure(Document& sheetDocument);
    void removeTemplateWhitespace(Node& node);
    void removeSourceWhitespace(Node& root);
    bool isConfigured() { return !preserves_->empty(); }

  private:
    typedef std::set<DOMString> NameSet;
    typedef std::deque<bool> StateStack;

    Pointer<NameSet> preserves_, strips_;

    Pointer<AndTest> preserveTests_;

    void addPreserves(DOMString& elements);
    void addStrips(DOMString& elements);
    void setPreserveTests();

    void configureSheet(Element& sheetElement);
    void configureWhitespaceElement(Element& sheetElement);
  };
}

#endif
