/***************************************************************************
                          xmldeclaration.h  -  description
                             -------------------
    begin                : Fri Mar 19 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XMLDECLARATION_H
#define XMLDECLARATION_H

#include "processinginstruction.h"
#include "domstring.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class XMLDeclaration : public ProcessingInstruction  {
  public:
  	XMLDeclaration(const DOMString& version, const DOMString& encoding,
          const DOMString& standalone);
    XMLDeclaration(const XMLDeclaration& refNode);
    XMLDeclaration& operator=(const XMLDeclaration& refNode);

    static XMLDeclaration failDeclaration;

    DOMString getData() const;
    DOMString getVersion() const;
    DOMString getEncoding() const;
    DOMString getStandAlone() const;
    DOMString getDisplayString() const;
    Node& cloneNode(bool deep = false) const;

  protected:
    XMLDeclaration& copy() { return *(new XMLDeclaration(*this)); }

  };
}

#endif
