/***************************************************************************
                          xmldeclarationcontent.cpp  -  description
                             -------------------
    begin                : Fri Mar 19 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "xmldeclarationcontent.h"

namespace limpid {

XMLDeclarationContent::XMLDeclarationContent(const DOMString& version,
    const DOMString& encoding, const DOMString& standalone):
    ProcessingInstructionContent("xml", ""), version_(0), encoding_(0), standalone_(0) {
  try {
    version_ = version.copyChars();
    encoding_ = encoding.copyChars();
    if (!standalone.empty()) standalone_ = standalone.copyChars();
  }
  catch (std::bad_alloc) {
    delete [] version_;
    delete [] encoding_;
    delete [] standalone_;
    throw;
  }
}

XMLDeclarationContent::~XMLDeclarationContent() {
  delete [] version_;
  delete [] encoding_;
  delete [] standalone_;
}

}
