/***************************************************************************
 *   Copyright (C) 2007 by John  Redmond                                   *
 *   john_redmond@optusnet.com.au                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LIMPIDXMLWRAPPER_H
#define LIMPIDXMLWRAPPER_H

#include "documentprocessor.h"
#include "domutils.h"

namespace limpid {
/**
	@author root <john_redmond@optusnet.com.au>
*/
class XMLWrapper : public DocumentProcessor, public DOMUtils {
public:
  XMLWrapper(const DOMString& screenStyle, const DOMString& printStyle):
    printStyle_(printStyle), screenStyle_(screenStyle), expandStyle_(false) {}
  Document& processDocument(Document& document);
  void setExpanding(bool expandStyle) { expandStyle_ = expandStyle; }
  XMLWrapper& copy() {  return *(new XMLWrapper(*this)); }

private:
  DOMString printStyle_, screenStyle_;
  bool expandStyle_;

  void buildHeadedDocument(Document& document);
  void buildSimpleDocument(Document& document);
  void setProlog(Document& document);
  void setBody(Document& document);
  void setHead(Document& document);
  void addTitle(Element& sourceElement, Element& headElement);
  void setStyles(Document& document);
  void addStyle(Element& parentElement, const DOMString& styleName, const DOMString& mediaString = "");
  void expandStyle(Element& parentElement, const DOMString& styleName, const DOMString& mediaString = "");
  void copyContent(Node& sourceNode, Node& destNode);

};

}

#endif
