/***************************************************************************
                          xpathexpression.h  -  description
                             -------------------
    begin                : Fri Nov 19 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XPATHEXPRESSION_H
#define XPATHEXPRESSION_H

#include "copied.h"
/**
  *@author John Redmond
  */

namespace limpid {
  class Boolean;
  class XPathString;
  class Number;
  class Context;
  class NodeSet;
  class Expr;

  class XPathExpression: public Copied {

  friend class Expr;

  public:
    virtual Boolean getBoolean(Context& context);
    virtual XPathString getString(Context& context);
    virtual Number getNumber(Context& context);
    virtual NodeSet getNodeSet(Context& context, bool exact = true);
    virtual Expr eval(Context& context);

    virtual double getPriority() { return -1000; }
    virtual bool isNodeSet() { return false; }
    virtual bool isBoolean() { return false; }
    virtual bool isValid() { return false; }

    virtual XPathExpression& copy() { return *(new XPathExpression); }

  protected:
    XPathExpression();
  };
}

#endif
