/***************************************************************************
                          xpathorganizer.h  -  description
                             -------------------
    begin                : Wed May 26 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XPATHORGANIZER_H
#define XPATHORGANIZER_H

#include "document.h"
#include "element.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class XPathOrganizer {
  public:
  	XPathOrganizer();

    void organize(Document& document);

  private:
    Element structureNode(Element& node);
    Element addStructure(Element& node, const char* groupNames,
        const char* groupLabel, bool includeOperators = true);
    Element processUnaryMinuses(Element& parent);
    void addLRStructure(Element& node, const char* groupNames, const char* structureName);
    Element getLRStructure(Element& root, const char* structureName);
    bool containsNode(Node& root, const char* nodeNames);
  };
}

#endif
