/***************************************************************************
                          xpathstring.cpp  -  description
                             -------------------
    begin                : Fri May 7 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "xpathstring.h"
#include "number.h"
#include "boolean.h"
#include "writer.h"
#include "domstring.h"
#include "expr.h"


namespace limpid {

XPathString::XPathString(): XPathExpression() {
}

XPathString::XPathString(const DOMString& string):
    DOMString(string), XPathExpression() {}

XPathString::XPathString(const char* string):
    DOMString(string), XPathExpression() {}

inline Boolean XPathString::getBoolean(Context&) { return static_cast<int>(size()); }

inline XPathString XPathString::getString(Context&) { return *this; }

inline Expr XPathString:: eval(Context&) { return *this; }

inline Number XPathString::getNumber(Context&) { return Number(*this); }

inline bool XPathString::isTrue() { return static_cast<int>(size()); }

XPathString errorString;

}
