/***************************************************************************
                          xpathstring.h  -  description
                             -------------------
    begin                : Fri May 7 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XPATHSTRING_H
#define XPATHSTRING_H

#include "number.h"
#include "boolean.h"
#include "writer.h"
#include "domstring.h"
#include "xpathexpression.h"

/**
  *@author John Redmond
  */

namespace limpid {
  class Boolean;
  class Number;
  class Expr;

  class XPathString : public DOMString, public XPathExpression  {
  public:
  	XPathString();
  	XPathString(const DOMString& string);
  	XPathString(const char* string);

    static XPathString errorString;
    bool isValid() { return true; }

    Boolean getBoolean(Context& context);
    XPathString getString(Context& context);
    Number getNumber(Context& context);
    Expr eval(Context& context);
    bool isTrue();

    XPathString& copy() { return *(new XPathString(*this)); }
  };
}
#endif
