/***************************************************************************
                          xsloutputter.cpp  -  description
                             -------------------
    begin                : Sat Mar 4 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "xsloutputter.h"
#include "writer.h"

namespace limpid {

XSLOutputter::XSLOutputter(bool isBuilding):
    styleSheet_(new StyleSheet(isBuilding)) {}

XSLOutputter::XSLOutputter(const DOMString& styleName, bool isBuilding):
    styleSheet_(new StyleSheet(styleName, isBuilding)) {}

XSLOutputter::XSLOutputter(const DOMString& styleName, const DOMString& destName,  bool isBuilding): destSpec_(destName),
    styleSheet_(new StyleSheet(styleName, isBuilding)) {
}

void XSLOutputter::update(const DOMString& destName) {
  // replace wildcard, if there is one
  destPath_ = destSpec_;
  destPath_.change("*", destName);
}

Document& XSLOutputter::processDocument(Document& inputDocument) {
  inputDocument.reorder();
  if (destPath_.getLength())
    styleSheet_->transformDocument(inputDocument, destPath_);
  else
    styleSheet_->transformDocument(inputDocument);

  return inputDocument;
}

}
