/***************************************************************************
                          xsloutputter.h  -  description
                             -------------------
    begin                : Sat Mar 4 2006
    copyright            : (C) 2006 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XSLOUTPUTTER_H
#define XSLOUTPUTTER_H

#include "documentprocessor.h"
#include "stylesheet.h"
#include "pointer.h"

/**
  *@author John Redmond
  */

namespace limpid {  
class XSLOutputter : public DocumentProcessor  {
public: 
    XSLOutputter(bool isBuilding = true);
  	XSLOutputter(const DOMString& styleName, bool isBuilding);
  	XSLOutputter(const DOMString& styleName, const DOMString& destName,
      bool isBuilding);

    Document& processDocument(Document& inputDocument);
    void update(const DOMString& destName);
    DocumentProcessor& copy() { return *(new XSLOutputter(*this)); }
    
private:
  DOMString destSpec_, destPath_;
  Pointer<StyleSheet> styleSheet_;
  bool isBuilding_;
};

}

#endif
