/***************************************************************************
                          xslutility.cpp  -  description
                             -------------------
    begin                : Wed Nov 17 2004
    copyright            : (C) 2004 by John Redmond
    email                : john_redmond@optusnet.com.au
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "xslutility.h"
#include "writer.h"
#include "nodestream.h"
#include "liststream.h"
#include "node.h"
#include "element.h"
#include "attr.h"
#include "nodelist.h"

namespace limpid {

XSLUtility::XSLUtility() {}

bool XSLUtility::isXSLElement(Node& node) {
  if (node.getNodeType() == Node::END_NODE)
    node = (static_cast<EndNode &>(node)).getStartNode();

  if (node.getNodeType() != Node::ELEMENT_NODE) return false;
  else return node.getNamespaceURI() == xslNamespace;
}

bool XSLUtility::isXSLAttribute(Node& node) {
  if (node.getNodeType() != Node::ATTRIBUTE_NODE) return false;
  else return node.getNamespaceURI() == xslNamespace;
}

Attr& XSLUtility::getXSLAttribute(Element& element, DOMString& name) {
  return element.getAttributeNodeNS(xslNamespace, name);
}

DOMString XSLUtility::getNodeName(Element& element) {
  DOMString name = element.getLocalName();
  if (!name.empty()) return name;
  else return element.getNodeName();
}

DOMString XSLUtility::getEndString(Element& element) {
  DOMString resultString = "</";
  resultString += element.getNodeName();
  resultString += ">";
  return resultString;
}

DOMString XSLUtility::getPrefix(DOMString& qname) {
  static DOMString colon = ":";
  size_t colonPos = qname.find(colon);
  if (colonPos == qname.npos)
    return "";
  else
    return qname.substring(0, colonPos);
}

DOMString XSLUtility::xslNamespace = "http://www.w3.org/1999/XSL/Transform";

}
